<?php
/**
 * "footer.php"
 * This template is used for rendering page footer.
 *
 * @package tantyyellow
 */

get_header();
?>

</main><!-- /#main -->

<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
<!-- +++++  03. In order to output 'Site Footer Content' ++++++++++++++++++++++++++++++++++++++++++++++++ -->

<footer id="footer" role="contentinfo">

	<?php
	if ( ! is_front_page() ) :
		?>
		<div id="footer-page-top-btn">
			<a href="#site" aria-label="<?php echo esc_attr__( 'Click this link to go back to the top of this page', 'tantyyellow' ); ?>">
				<ul>
					<li></li>
					<li></li>
					<li></li>
				</ul>
				<p class="font-family_subheading_level">
					<?php esc_html_e( 'PAGE TOP', 'tantyyellow' ); ?>
				</p>
			</a>
		</div>
		<?php
	endif;
	?>

		<p class="copyright">

			&copy; <?php echo esc_html( wp_date( 'Y' ) ); ?>

			<a href="<?php echo esc_url( home_url( '/' ) ); ?>" aria-label="<?php echo esc_attr__( 'Click this link to move on to the site homepage.', 'tantyyellow' ); ?>"><?php bloginfo( 'name' ); ?></a>, <?php esc_html_e( 'All rights reserved.', 'tantyyellow' ); ?>

		</p><!-- /.copyright -->

</footer><!-- /#footer -->

</div><!-- /.site-inner -->

</div><!-- /#site -->



<?php
wp_footer(); /* Always must have this just before the closing </body> tag of your theme, or you will break many plugins, which generally use this hook to reference JavaScript files */
?>



<?php
/**
 * Code to load 'jQuery' is not necessary because it's loaded by WP by default.
 * All <script>s are defined at 'functions/scripts.php' by 'wp_enqueue_script'
 */
?>



</body>

</html>
