<?php
/**
 * This file contains a set of functions in order to get some value.
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### Functions in order to get something like 'path', 'name', 'value', and so on ######################################
// ########################################################################################################################

/**
 * Get the name of category.
 * ( Just get only the main category not its parent categories )
 *
 * @return string The main category name.
 */
function tantyyellow_get_the_category_name() {
	$category_meta_obj = get_the_category(); // If using 'get_the_category( the_ID() )', number is added before a category's name.
	return $category_meta_obj[0]->name;
}



/**
 * Get the name of tag.
 * ( Just get only the first tag not all tags )
 *
 * @return string The first tag name.
 */
function tantyyellow_get_the_tag_name() {
	$tag_meta_obj = get_the_tags();
	return $tag_meta_obj[0]->name;
}
