<?php
/**
 * "index.php"
 *
 * @package tantyyellow
 */

get_header();
?>



<!-- Contents of main -->
<div id="main-contents" class="contents contents-width-100 row">

	<!-- Right colum of main contents -->
	<div id="contents-sidebar" class="contents-sidebar contents-sidebar-is-index-page width-pc width-tablet" role="navigation" aria-label="<?php esc_attr_e( 'Widgets Sidebar', 'tantyyellow' ); ?>">

		<!-- Load sidebar.php -->
		<?php get_sidebar(); ?>

	</div><!-- /#contents-sidebar-is-index-page -->



	<!-- Left colum of main contents -->
	<div id="contents-main" class="col-9 bg-light focusable_elem" aria-label="<?php echo esc_attr__( 'This is the main content of this page', 'tantyyellow' ); ?>" tabindex="0">

		<!-- If there are posts... -->
		<?php
		get_template_part( './template-parts/contents/contents', 'heading' );

		if ( is_home() || is_front_page() || is_archive() || is_search() ) :
			get_template_part( './template-parts/contents/loops/loop', 'main' );

		elseif ( is_page() ) :
			get_template_part( './template-parts/contents/loops/loop', 'page' );

		elseif ( is_single() ) :
			get_template_part( './template-parts/contents/loops/loop', 'single' );

		elseif ( is_404() ) :
			?>
			<p class="not-found-icon"><i class="fas fa-exclamation-triangle"></i></p>
			<p class="not-found-apology">
				<?php esc_html_e( 'We are sorry, but the page you are looking for doesn\'t exist, has been removed, or doesn\'t allow you to access this page.', 'tantyyellow' ); ?>
			</p>
			<?php

		endif;
		?>

	</div><!-- /#contents-main -->

</div><!-- /#main-contents -->



<!-- Load footer.php -->
<?php
get_footer();
