<?php
/**
 * Template Name: Full width with Sidebar
 * This template has "Full Width" feature with "Sidebar"
 *
 * @package tantyyellow
 */

esc_html__( 'Full width with Sidebar', 'tantyyellow' );
?>



<!-- Load header.php -->
<?php get_header(); ?>



<!-- Contents of main -->
<div class="contents contents-width-100 is_page is_custom_page row">

	<!-- Right colum of main contents -->
	<div id="contents-sidebar" class="contents-sidebar contents-sidebar-is-page width-pc width-tablet" role="navigation" aria-label="<?php esc_attr_e( 'Widgets Sidebar', 'tantyyellow' ); ?>">

		<?php get_sidebar(); ?>

	</div><!-- /#contents-sidebar-is-page -->



	<!-- Left colum of main contents -->
	<div id="contents-main" class="custom-page-fullwidth focusable_elem" aria-label="<?php echo esc_attr__( 'This is the main content of this page', 'tantyyellow' ); ?>" tabindex="0">

		<?php
		if ( have_posts() ) :

			while ( have_posts() ) :

				the_post();

				if ( get_the_content() ) {

					the_content();

					wp_link_pages(
						array(
							'before'         => '<div class="each-post-content-page-links">',
							'after'          => '</div>',
							'link_before'    => '<span>',
							'link_after'     => '</span>',
							'next_or_number' => 'number',
						)
					);

				} else {
					tantyyellow_output_template_parts_nothing_exists_message();
				}

			endwhile;

		endif;
		?>

	</div>

</div><!-- /.contents -->



<!-- Load footer.php -->
<?php
get_footer();
