<?php
/**
 * "sidebar.php"
 * This template is used for rendering a page side bar.
 *
 * @package tantyyellow
 */

get_header();
?>



<?php
if ( is_active_sidebar( 'main-sidebar' ) ) : /* If widget is registered at 'Appearance -> Widgets'... */
	?>

<div id="sidebar-widgets-rightside-toggle-btn-wrapper">
	<button type="button" id="sidebar-widgets-rightside-toggle-btn" aria-label="<?php echo esc_attr__( 'Click this button in order to expand or collapse the "Widgets Sidebar" at the right of the page', 'tantyyellow' ); ?>">
		<ul>
			<li></li>
			<li></li>
			<li></li>
		</ul>
	</button>
	<p class="font-family_subheading_level<?php echo ( 'ja' === get_locale() ) ? ' lang-ja' : ''; ?>"><?php esc_html_e( 'SIDEBAR', 'tantyyellow' ); ?></p>
</div>

	<?php
endif;
?>



<div class="contents-sidebar-wrapper">

	<div class="contents-sidebar-inner">

		<aside class="sidebar" role="complementary">

			<?php
			if ( is_active_sidebar( 'main-sidebar' ) ) :
				dynamic_sidebar( 'main-sidebar' ); /* Apply the ID that is defined in register_sidebar() in functions.php to display widget */

			else :
				?>

			<!-- Recent posts -->
			<section class="widget widget_recent_entries">
				<h5 class="widget-title font-family_subheading_level focusable_elem" tabindex="0"><?php esc_html_e( 'RECENT POSTS', 'tantyyellow' ); ?></h5>
				<ul>
					<?php
					$tantyyellow_wp_get_archives_args_for_sidebar_recent_entries = array(
						'type'            => 'postbypost', /* 'postbypost' -> Recent */
						'limit'           => 5,
						'format'          => 'html', /* html -> Displaying with <li> */
						'before'          => '',
						'after'           => '',
						'show_post_count' => 0, /* Whether displaying the number of posts(1) or not(0) */
					);
					wp_get_archives( $tantyyellow_wp_get_archives_args_for_sidebar_recent_entries );
					?>
				</ul>
			</section>



			<!-- Categories -->
			<section class="widget widget_categories">
				<h5 class="widget-title font-family_subheading_level focusable_elem" tabindex="0"><?php esc_html_e( 'CATEGORIES', 'tantyyellow' ); ?></h5>
				<ul>
					<?php
					$tantyyellow_wp_list_categories_args_for_sidebar = array(
						'style'              => 'list',
						'show_count'         => true, /* Whether displaying the number of posts(true) or not(false) */
						'use_desc_for_title' => true, /* Whether add description as 'title' attribute in <a>(true) or not(false) */
						'title_li'           => '',
						'depth'              => 2, /* Depth of categories hierarchy(0 -> Show all children categories) */
						'exclude'            => '', /* ID that must not be displayed */
					);
					wp_list_categories( $tantyyellow_wp_list_categories_args_for_sidebar );
					?>
				</ul>
			</section>



			<!-- Tags -->
			<section class="widget widget_tag_cloud">
				<h5 class="widget-title font-family_subheading_level focusable_elem" tabindex="0"><?php esc_html_e( 'TAGS', 'tantyyellow' ); ?></h5>
				<div class="tagcloud">
					<?php
					$tantyyellow_wp_get_archives_args_for_sidebar_tag_cloud = array(
						'taxonomy' => 'post_tag',
						'orderby'  => 'count',
						'order'    => 'DESC',
					);

					$tantyyellow_new_wp_term_query_for_sidebar_tag_cloud = new WP_Term_Query( $tantyyellow_wp_get_archives_args_for_sidebar_tag_cloud );

					foreach ( $tantyyellow_new_wp_term_query_for_sidebar_tag_cloud->get_terms() as $tantyyellow_each_term ) :
						echo '<li><a href="' . esc_url( get_term_link( $tantyyellow_each_term ) ) . '">' . esc_html( $tantyyellow_each_term->name ) . ' (' . esc_html( $tantyyellow_each_term->count ) . ')</a></li>';

					endforeach;
					?>

				</div>
			</section>



			<!-- Archives -->
			<section class="widget widget_archive">

				<h5 class="widget-title font-family_subheading_level focusable_elem" tabindex="0"><?php esc_html_e( 'ARCHIVES', 'tantyyellow' ); ?></h5>

				<!-- Weekly archives -->
				<h6><?php esc_html_e( 'Weekly Archives', 'tantyyellow' ); ?></h6>
				<select name="archive-dropdown" onChange="document.location.href=this.options[this.selectedIndex].value;">
					<option><?php esc_html_e( 'Weekly', 'tantyyellow' ); ?></option>
					<?php
					$tantyyellow_wp_get_archives_args_for_sidebar_weekly_archives = array(
						'type'            => 'weekly',
						'limit'           => 10,
						'format'          => 'option',
						'before'          => '',
						'after'           => '',
						'show_post_count' => 1,
					);
					wp_get_archives( $tantyyellow_wp_get_archives_args_for_sidebar_weekly_archives );
					?>
				</select>

				<!-- Monthly archives -->
				<h6><?php esc_html_e( 'Monthly Archives', 'tantyyellow' ); ?></h6>
				<select name="archive-dropdown" onChange="document.location.href=this.options[this.selectedIndex].value;">
					<option><?php esc_html_e( 'Monthly', 'tantyyellow' ); ?></option>
					<?php
					$tantyyellow_wp_get_archives_args_for_sidebar_monthly_archives = array(
						'type'            => 'monthly',
						'limit'           => 12,
						'format'          => 'option',
						'before'          => '',
						'after'           => '',
						'show_post_count' => 1,
					);
					wp_get_archives( $tantyyellow_wp_get_archives_args_for_sidebar_monthly_archives );
					?>
				</select>

				<!-- Yearly archives -->
				<h6><?php esc_html_e( 'Yearly Archives', 'tantyyellow' ); ?></h6>
				<select name="archive-dropdown" onChange="document.location.href=this.options[this.selectedIndex].value;">
					<option><?php esc_html_e( 'Yearly', 'tantyyellow' ); ?></option>
					<?php
					$tantyyellow_wp_get_archives_args_for_sidebar_yearly_archives = array(
						'type'            => 'yearly',
						'limit'           => 3,
						'format'          => 'option',
						'before'          => '',
						'after'           => '',
						'show_post_count' => 1,
					);
					wp_get_archives( $tantyyellow_wp_get_archives_args_for_sidebar_yearly_archives );
					?>
				</select>

			</section>

				<?php
			endif;
			?>

		</aside><!-- /.sidebar -->

	</div><!-- /.contents-sidebar-inner -->

</div><!-- /.contents-sidebar-wrapper -->
