<?php
/**
 * "class-tantyyellow-wp-customize-panel.php"
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### Classes for 'Contact Page' to enable customizer "Panel" to nest deeper ###########################################
// ########################################################################################################################

if ( class_exists( 'WP_Customize_Panel' ) ) {

	/**
	 * Custom WP_Customize_Panel
	 * In order to enable customizer Panel to nest deeper.
	 *
	 * @var mixed  $panel
	 *
	 * @var string $type Type of the panel.
	 *
	 * @link https://gist.github.com/OriginalEXE
	 * @link https://gist.github.com/OriginalEXE/9a6183e09f4cae2f30b006232bb154af
	 *
	 * @link tantyyellow_customizer_enable_panel_section_deeper_nesting.js
	 * @link tantyyellow_customizer_enable_panel_section_deeper_nesting.css
	 */
	class Tantyyellow_WP_Customize_Panel extends WP_Customize_Panel {

		/**
		 * Public variable $panel.
		 *
		 * @var WP_Customize_Panel $panel WP_Customize_Panel instance.
		 */
		public $panel;

		/**
		 * Public variable $type.
		 *
		 * @var string $type Type of the panel.
		 */
		public $type = 'pe_panel';

		/**
		 * Gather the parameters passed to client JavaScript via JSON.
		 *
		 * @return array The array to be exported to the client as JSON.
		 */
		public function json() {

			$array                   = wp_array_slice_assoc( (array) $this, array( 'id', 'description', 'priority', 'type', 'panel' ) );
			$array['title']          = html_entity_decode( $this->title, ENT_QUOTES, get_bloginfo( 'charset' ) );
			$array['content']        = $this->get_content();
			$array['active']         = $this->active();
			$array['instanceNumber'] = $this->instance_number;

			return $array;

		}

	}

}
