<?php
/**
 * "class-tantyyellow-wp-customize-section.php"
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### Classes for 'Contact Page' to enable customizer "Section" to nest deeper #########################################
// ########################################################################################################################

if ( class_exists( 'WP_Customize_Section' ) ) {

	/**
	 * Custom WP_Customize_Section
	 * In order to enable customizer Section to nest deeper.
	 *
	 * @var mixed $section
	 *
	 * @var string $type Type of the section.
	 *
	 * @link https://gist.github.com/OriginalEXE
	 * @link https://gist.github.com/OriginalEXE/9a6183e09f4cae2f30b006232bb154af
	 *
	 * @link tantyyellow_customizer_enable_panel_section_deeper_nesting.js
	 * @link tantyyellow_customizer_enable_panel_section_deeper_nesting.css
	 */
	class Tantyyellow_WP_Customize_Section extends WP_Customize_Section {

		/**
		 * Public variable $section.
		 *
		 * @var WP_Customize_Panel $section WP_Customize_Section instance.
		 */
		public $section;

		/**
		 * Public variable $type.
		 *
		 * @var string $type Type of the panel.
		 */
		public $type = 'pe_section';

		/**
		 * Gather the parameters passed to client JavaScript via JSON.
		 *
		 * @return array The array to be exported to the client as JSON.
		 */
		public function json() {

			$array = wp_array_slice_assoc(
				(array) $this,
				array(
					'id',
					'description',
					'priority',
					'panel',
					'type',
					'description_hidden',
					'section',
				)
			);

			$array['title']          = html_entity_decode( $this->title, ENT_QUOTES, get_bloginfo( 'charset' ) );
			$array['content']        = $this->get_content();
			$array['active']         = $this->active();
			$array['instanceNumber'] = $this->instance_number;

			if ( $this->panel ) {

				$array['customizeAction'] = sprintf( 'Customizing &#9656; %s', esc_html( $this->manager->get_panel( $this->panel )->title ) );

			} else {

				$array['customizeAction'] = 'Customizing';

			}

			return $array;

		}

	}

}
