<?php
/**
 * "tantyyellow-customizer-enable-panel-section-deeper-nesting.php"
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### Register and enqueue Script & CSS for Classes above ##############################################################
// ########################################################################################################################

/**
 * Register and Enqueue script for deeper nesting in customizer Panel & Section.
 */
function tantyyellow_load_customizer_enable_panel_section_deeper_nesting_script() {

	$theme_ver = wp_get_theme()->get( 'Version' );

	// Enable customizer to nest more than 2 Panels & Sections.
	wp_enqueue_script( 'tantyyellow-script-customizer-enable-panel-section-deeper-nesting', get_theme_file_uri( '/src/admin/customize_admin_panel/customizer_enable_panel_section_deeper_nesting/tantyyellow_customizer_enable_panel_section_deeper_nesting.js' ), array(), $theme_ver, true );
}
add_action( 'customize_controls_enqueue_scripts', 'tantyyellow_load_customizer_enable_panel_section_deeper_nesting_script' );

/**
 * Register and Enqueue styles for deeper nesting in customizer Panel & Section.
 */
function tantyyellow_load_customizer_enable_panel_section_deeper_nesting_styles() {

	$theme_ver = wp_get_theme()->get( 'Version' );

	/* Style admin panel theme customizer screen */
	wp_enqueue_style( 'tantyyellow-style-customizer-enable-panel-section-deeper-nesting', get_theme_file_uri( '/src/admin/customize_admin_panel/customizer_enable_panel_section_deeper_nesting/tantyyellow_customizer_enable_panel_section_deeper_nesting.css' ), array(), $theme_ver, 'all' );
}
add_action( 'customize_controls_print_styles', 'tantyyellow_load_customizer_enable_panel_section_deeper_nesting_styles' );



// ########################################################################################################################
// ##### Here is an example of how to use Classes above ###################################################################
// ########################################################################################################################

// /**
//  * Define function for action hook "customize_register".
//  * - Register theme customizer for enabling "Panel" & "Section" in the customizer menu to nest deeper.
//  *
//  * @param WP_Customize_Manager $wp_customize Customizer object, which is an instance of the WP_Customize_Manager class.
//  */
// function tantyyellow_theme_customizer_register_enable_panel_section_deeper_nesting( $wp_customize ) {

// 	// Has to be at the top.
// 	$wp_customize->register_panel_type( 'Tantyyellow_WP_Customize_Panel' );
// 	$wp_customize->register_section_type( 'Tantyyellow_WP_Customize_Section' );

// }
// add_action( 'customize_register', 'tantyyellow_theme_customizer_register_enable_panel_section_deeper_nesting' );
