( function ( $ ) {

	/**
	 * In order to manipulate the content in "Contact Page Members" settings in the "Customizer".
	 *
	 * @link https://dev.to/lebcit/creating-a-customizer-control-with-javascript-1k6h
	 * @link https://developer.wordpress.org/themes/customize-api/the-customizer-javascript-api/
	 * @link https://make.wordpress.org/core/2017/11/01/improvements-to-the-customize-js-api-in-4-9/
	 */
	wp.customize.bind( "ready", function () {

		var api = this;

		/* ######################################################################################################################## */
		/* ##### Site Basics Settings ############################################################################################# */
		/* ######################################################################################################################## */

		/* ************************************************************************************************************** */
		/* ***** Site Basics Settings --> Pages Settings **************************************************************** */
		/* ************************************************************************************************************** */

		/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
		/* +++++ Site Basics Settings --> Pages Settings --> Custom Posts Number per Page +++++++++++++++++++++ */

		// Customizer "Pages => Custom Posts Number per Page => Enable Custom Posts Number per Page" settings section's <ul>.
		var ulPages_customPostsNum = document.getElementById( "sub-accordion-section-site_basics_subsection_custom_posts_num_per_page" );

		api( "site_basics_subsection_custom_posts_num_per_page_onoff_setting", function( value ){

			var initialValue = value.get();

			toggle_class_for_site_basics_subsection_custom_posts_num_per_page_onoff( ulPages_customPostsNum, initialValue );

			value.bind( function ( val ) {
				var updatedValue = val;

				toggle_class_for_site_basics_subsection_custom_posts_num_per_page_onoff( ulPages_customPostsNum, updatedValue );
			});
		});

		function toggle_class_for_site_basics_subsection_custom_posts_num_per_page_onoff( var_ul, var_value ) {

			if ( "off" === var_value ) {
				var_ul.classList.add( "site_basics_subsection_custom_posts_num_per_page_onoff_is_off" );
				var_ul.classList.remove( "site_basics_subsection_custom_posts_num_per_page_onoff_is_on" );

			} else if ( "on" === var_value ) {
				var_ul.classList.add( "site_basics_subsection_custom_posts_num_per_page_onoff_is_on" );
				var_ul.classList.remove( "site_basics_subsection_custom_posts_num_per_page_onoff_is_off" );
			}
		}

		/* ************************************************************************************************************** */
		/* ***** Site Basics Settings --> Posts Settings **************************************************************** */
		/* ************************************************************************************************************** */

		/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
		/* +++++ Site Basics Settings --> Posts Settings --> Each Post Settings ( Archive Pages ) +++++++++++++ */

		// Customizer "Posts => Each Posts" settings section's <ul>.
		var ul_Posts_eachPost = document.getElementById( "sub-accordion-section-site_basics_section_posts_subsection_each_post_archive_pages" );

		api( "site_basics_posts_each_post_archive_pages_excerpt_length_custom_length_setting", function( value ){

			var initialValue = value.get();

			toggle_class_for_site_basics_posts_each_post_archive_pages_excerpt_length_custom_length( ul_Posts_eachPost, initialValue );

			value.bind( function ( val ) {
				var updatedValue = val;

				toggle_class_for_site_basics_posts_each_post_archive_pages_excerpt_length_custom_length( ul_Posts_eachPost, updatedValue );
			});
		});

		function toggle_class_for_site_basics_posts_each_post_archive_pages_excerpt_length_custom_length( var_ul, var_value ) {

			if ( "off" === var_value ) {
				var_ul.classList.add( "site_basics_posts_each_post_archive_pages_excerpt_length_custom_length_is_off" );
				var_ul.classList.remove( "site_basics_posts_each_post_archive_pages_excerpt_length_custom_length_is_on" );

			} else if ( "on" === var_value ) {
				var_ul.classList.add( "site_basics_posts_each_post_archive_pages_excerpt_length_custom_length_is_on" );
				var_ul.classList.remove( "site_basics_posts_each_post_archive_pages_excerpt_length_custom_length_is_off" );
			}
		}

	}); // End of "wp.customize.bind( "ready", function () {".



	/**
	 * In order to show the value of the current number selected by a range slider in "Customizer" in "Admin Panel".
	 *
	 * @see functions/classes/class-tantyyellow-customizer-range-control.php
	 *
	 * @link https://w3guy.com/wordpress-customizer-range-control-selected-indicator/ "Range Control with Selected Value Indicator"
	 */
	$( document ).ready( function ( $ ) {
		$( "input[data-input-type]" ).on( "input change", function () {
			var val = $( this ).val();
			$( this ).prev( ".cs-range-value-wrapper" ).children( "#cs-range-value" ).html( val );
			$( this ).val( val );
		} );
	});

})( jQuery );
