/* ######################################################################################################################## */
/* ##### tantyyellow_admin_panel.js ####################################################################################### */
/* ######################################################################################################################## */

/* ************************************************************************************************************** */
/* ***** In order to initialize 'Admin Panel' ******************************************************************* */
/* ************************************************************************************************************** */

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++ Beginning of Pure Javascript +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

document.addEventListener ( "DOMContentLoaded", tantyyellow_init_admin_panel_JS );

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
function tantyyellow_init_admin_panel_JS () { /* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++ Beginning of Pure Javascript +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

	/* ========================================================================================== */
	/* ===== Settings Panel ===================================================================== */

	/* ===== Discussion ========================================================================= */
	/**
	* This is for the setting "Comments should be displayed with the newer comments at the top of each page"
	* in order to change "older ==> newer" and "newer ==> older" in "Admin Panel ==> Settings Tab ==> Discussion".
	*/
	var comment_order_select = document.getElementById( "comment_order" );

	if ( comment_order_select ) {

		var comment_order_select_opts = comment_order_select.getElementsByTagName( "option" );

		if ( comment_order_select_opts ) {

			// Get the data passed from PHP by using add_action( 'admin_enqueue_scripts', 'tantyyellow_load_admin_panel_scripts_in_head' ) in "script.php".
			var php_vals_arr = ( tantyyellow_arr_passing_php_data_to_admin_panel_js ) ? tantyyellow_arr_passing_php_data_to_admin_panel_js : array();

			// Extract the value stored in the array gotten from PHP.
			var page_comments_order_select_opt_newer = php_vals_arr["admin"]["settings"]["discussion"]["each_page_comment_order"]["newer"];
			page_comments_order_select_opt_newer = ( page_comments_order_select_opt_newer ) ? page_comments_order_select_opt_newer : "newer";

			var page_comments_order_select_opt_older = php_vals_arr["admin"]["settings"]["discussion"]["each_page_comment_order"]["older"];
			page_comments_order_select_opt_older = ( page_comments_order_select_opt_older ) ? page_comments_order_select_opt_older : "older";

			// Change the text "older ==> newer" and "newer ==> older".
			for ( var i = 0, len = comment_order_select_opts.length; i < len; i++ ) {
				if ( "asc" === comment_order_select_opts[i].getAttribute( "value" ) ) {
					comment_order_select_opts[i].innerHTML = page_comments_order_select_opt_newer;
				} else {
					comment_order_select_opts[i].innerHTML = page_comments_order_select_opt_older;
				}
			}
		}
	}


/* +++++ End of Pure Javascript +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
} /* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */