/* ######################################################################################################################## */
/* ##### user-agent-parser-init.js ######################################################################################## */
/* ######################################################################################################################## */

/* ************************************************************************************************************** */
/* ***** In order to initialize 'UAParser.js' and generate object storing 'User Agent Information' ************** */
/* ************************************************************************************************************** */

/* Referejce : https://github.com/faisalman/ua-parser-js */

document.addEventListener( "DOMContentLoaded", function(){

	var parser = new UAParser();

	// by default it takes ua string from current browser's window.navigator.userAgent
	var userAgentInfos = parser.getResult();

	var browserName = parser.getBrowser().name;
	var browserVer  = parser.getBrowser().version;

	var osName      = parser.getOS().name;

	var deviceType  = parser.getDevice().type;



	/* ===== In order to add classes for the current browser's name & version into <body> ======= */
	var bodyElm = document.getElementsByTagName( "body" )[0];

	var browserNameFixed = browserName.replace( /\s+/g, "" ).toLowerCase();
	var browserVerFixed  = parseInt( browserVer.replace( /\s+/g, "" ).toLowerCase() );

	bodyElm.classList.add( "browser_name_" + browserNameFixed );
	bodyElm.classList.add( "browser_ver_"  + browserVerFixed );



	/* ===== In order to add class into each <video> if iOS device is being used ================ */
	if ( "iOS" === userAgentInfos.os.name ) {
		var videos = document.getElementsByTagName( "video" );
		if ( videos ) {
			for ( var i = 0, len = videos.length; i < len; i++ ) {
				videos[i].classList.add( "ua_device_os_ios" );
			}
		}
	}

});