/* ######################################################################################################################## */
/* ##### balloonCSS-copy-to-clipboard-init.js ############################################################################# */
/* ######################################################################################################################## */

/* ************************************************************************************************************** */
/* ***** In order to copy the text of the clicked element to clipboard ****************************************** */
/* ***** & In order to change the 'Balloon text' of it to 'Copied!' when completing copying it ****************** */
/* ************************************************************************************************************** */

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++ For Contact Page Header Address, Phone, Fax, & E-mail Section ++++++++++++++++++++++++++++++++ */

jQuery( document ).ready( function(){

    jQuery( ".allow_copy_to_clipboard" ).on( "click keypress", function (e) {

		if ( "click" === e.type || ( ( "keypress" === e.type ) && ( "Enter" === e.key ) ) ) {

			/* ----- In order to keep the original value of 'Balloon text' -------------------- */
			var balloonOriginalValue = this.getAttribute( "data-balloon" );

			/* ----- In order to copy to clipboard -------------------------------------------- */
			tantyyellow_selectDomElm( this );
			document.execCommand( "copy" );
			document.getSelection().removeAllRanges();

			var self = this;

			/* ----- In order to change 'Balloon text' from 'Click to copy' to 'Copied!' ------ */
			setTimeout( function () {
				self.removeAttribute( "data-balloon" );
			}, 200 );
			setTimeout( function () {
				self.setAttribute( "data-balloon", "Copied!" );
			}, 500 );
			setTimeout( function () {
				self.removeAttribute( "data-balloon" );
			}, 2000 );
			setTimeout( function () {
				self.setAttribute( "data-balloon", balloonOriginalValue );
			}, 4000 );
		}
	});

    function tantyyellow_selectDomElm( obj ) {

        /* ----- In order to get 'Range' object ------------------------------------------- */
        var range = document.createRange();

        /* ----- In order to define the range --------------------------------------------- */
        range.selectNodeContents( obj );

        /* ----- In order to return 'Selection' object storeing range a user selects ------ */
        var selection = window.getSelection();

        /* ----- In order to remove all selected ranges ----------------------------------- */
        selection.removeAllRanges();

        /* ----- In order to set a new range as 'Selection' ------------------------------- */
        selection.addRange( range );
    }



    /* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
    /* +++++ For Contact Page Each Member E-mail Section ++++++++++++++++++++++++++++++++++++++++++++++++++ */

    jQuery( ".allow_copy_to_clipboard_for_input" ).on( "click keypress", function (e) {

		if ( "click" === e.type || ( ( "keypress" === e.type ) && ( "Enter" === e.key ) ) ) {

			var eTarget = e.target;

			/* ----- In order to copy to clipboard -------------------------------------------- */
			eTarget.focus();
			eTarget.select();
			document.execCommand( "copy" );

			/* ----- Get event target parent elem with data-balloon="Click to Copy Email" ----- */
			var balloonElem = eTarget.parentElement;

			/* ----- In order to change 'Balloon text' from 'Click to copy' to 'Copied!' ------ */
			setTimeout( function () {
				balloonElem.removeAttribute( "data-balloon" );
			}, 500 );
			setTimeout( function () {
				balloonElem.setAttribute( "data-balloon", "Copied!" );
			}, 1500 );
			setTimeout( function () {
				balloonElem.removeAttribute( "data-balloon" );
			}, 3000 );
			setTimeout( function () {
				balloonElem.setAttribute( "data-balloon", "Click to Copy Email" );
			}, 5000 );
		}

	});



/* +++++ End of jQuery ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
});
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */