var _TantyyellowMainJSModule = {
	trap_focus_inside_modal: _trap_focus_inside_modal,
	// hello: function( name ) {
	// 	console.log( "Hello, this file's name is " + name + "!!!" );
	// }
}
export var TantyyellowMainJSModule = TantyyellowMainJSModule || _TantyyellowMainJSModule;

// var TantyyellowMainJSModule = TantyyellowMainJSModule || {

	/**
	 * ==================================================================================================================================
	 * Trap focus inside the modal as long as the modal is open.
	 *
	 * @link https://uxdesign.cc/how-to-trap-focus-inside-modal-to-make-it-ada-compliant-6a50f9a70700 "How to trap focus inside modal"
	 */
	function _trap_focus_inside_modal( _target_modal, _class_when_expanded, _QUERY_STR_FOR_KYBD_ACSS_ELEMS ) {

		// console.log( "_trap_focus_inside_modal() for " + _class_when_expanded + " is executed!" );

		if ( _target_modal ) {

			var kyBdAcssElems = _target_modal.querySelectorAll( _QUERY_STR_FOR_KYBD_ACSS_ELEMS );
			var elemsLength = kyBdAcssElems.length;
			// console.log( _class_when_expanded + "'s length => " + elemsLength );

			// If the only keyboard-accessible element is a button to toggle a modal.....
			if ( 2 > elemsLength ) {
				return;

			// If there is/are keyboard-accessible element(s) other than a button to toggle a modal.....
			} else {

				var kyBdAcssElem_1st = kyBdAcssElems[0];
				var kyBdAcssElem_end = kyBdAcssElems[elemsLength - 1];
				// console.log( _class_when_expanded + "'s 1st element => " + kyBdAcssElem_1st );
				// console.log( _class_when_expanded + "'s final element => " + kyBdAcssElem_end );

				kyBdAcssElem_1st.addEventListener( "keydown", focus_final_kybd_acss_elem );
				kyBdAcssElem_end.addEventListener( "keydown", focus_1st_kybd_acss_elem );

				// Focus the last keyboard accessible element.
				function focus_final_kybd_acss_elem(e){
					// If the pressed key is not "Tab".....
					if ( "Tab" !== e.key ) {
						return;
					}
					// If "shift" key is pressed with "tab".....
					if ( e.shiftKey ) {
						if ( _target_modal.classList.contains( _class_when_expanded ) ) {
							kyBdAcssElem_end.focus();
							e.preventDefault();
						}
					}
				}

				// Focus the first keyboard accessible element.
				function focus_1st_kybd_acss_elem(e){
					if ( "Tab" !== e.key ) {
						return;
					}
					// If "tab" key is pressed.....
					if ( ! e.shiftKey ) {
						if ( _target_modal.classList.contains( _class_when_expanded ) ) {
							kyBdAcssElem_1st.focus();
							e.preventDefault();
						}
					}
				}
			}
		}
	}
// }
// export { TantyyellowMainJSModule };
