import { TantyyellowMainJSModule } from "./main-module.js";
// TantyyellowMainJSModule.hello( "main.js" );



document.addEventListener( "DOMContentLoaded", tantyyellow_main_js );

function tantyyellow_main_js() {

	"use strict";

	// console.log( "main.js is successfully loaded!!!" );

	/* ######################################################################################################################## */
	/* ##### Pure Javascript ################################################################################################## */
	/* ######################################################################################################################## */

	/* ************************************************************************************************************** */
	/* ***** Common consts ****************************************************************************************** */
	/* ************************************************************************************************************** */

	// The const of the breakpoint between the PC and tablet sizes.
	const BREAKPOINT_PC_TABLET          = 960;
	const QUERY_STR_FOR_KYBD_ACSS_ELEMS = "a[href], button, input:not([disabled]):not([type=\"hidden\"]), select:not([disabled]), textarea:not([disabled]), [tabindex]:not([tabindex=\"-1\"]), .focusable_elem:not([disabled]):not([tabindex=\"-1\"])";



	/* ************************************************************************************************************** */
	/* ***** Common variables *************************************************************************************** */
	/* ************************************************************************************************************** */

	var site                              = document.getElementById( "site" );
	var siteHeader                        = document.getElementById( "site-header" );
	var headerNavLeftSidebar              = document.getElementById( "header-nav-sidebar-wrapper" );
	var headerNavList                     = document.getElementById( "header-nav-list" );
	var headerNavLeftSidebarKyBdAcssElems = headerNavLeftSidebar.querySelectorAll( QUERY_STR_FOR_KYBD_ACSS_ELEMS );

	var contentsMain = document.getElementById( "contents-main" );

	var widgetsRightSidebar               = document.getElementById( "contents-sidebar" );

	var eachPostRelatedPostsList       = document.getElementById( "each-post-related-posts" );
	var eachPostRelatedPostsListHeader = document.getElementById( "each-post-related-posts-header" );

	var eachPostCommentsList       = document.getElementById( "comments" );
	var eachPostCommentsListHeader = document.getElementById( "comments_header" );

	var eachPostPingsList       = document.getElementById( "pings" );
	var eachPostPingsListHeader = document.getElementById( "pings_header" );



	/* ************************************************************************************************************** */
	/* ***** Extracted array passed from PHP ************************************************************************ */
	/* ************************************************************************************************************** */



	/* ************************************************************************************************************** */
	/* ***** Commons ************************************************************************************************ */
	/* ************************************************************************************************************** */

	/* ===== In order to close the alert massage "IE unsupported!" ============================== */
	var alertIe         = document.getElementById( "alert_ie" );
	var closeAlertIeBtn = document.getElementById( "close_alert_ie_btn" );

	if ( alertIe && closeAlertIeBtn ) {
		closeAlertIeBtn.addEventListener( "click", function(){
			alertIe.classList.add( "fadeout_alert_ie" );
			setTimeout(function(){
				alertIe.classList.add( "close_alert_ie" );
			}, 1000 );
		});
	}



	/* ===== Jump to the main content when "Skip to Main Content" button is enter-key-pressed === */
	var skipToContentBtn = document.getElementById( "skip_to_the_content_btn" );
	/**
	 * @link https://developer.mozilla.org/en-US/docs/Web/API/HTMLOrForeignElement/focus "focus()"
	 */
	skipToContentBtn.addEventListener( "keydown", function(e){
		if (contentsMain ) {
			if ( "Enter" === e.key ) {
				// Because focus() works only for form elements by default, add attribute tabindex="0" to make <div id="contents-main"> focusable.
				contentsMain.setAttribute( "tabindex", "0" );
				contentsMain.focus({ preventScroll: false }); // false: Browser will scroll the element into view after focusing it.
			}
		}
	});



	/**
	 * ==================================================================================================================================
	 * Remove "outline" style when a element is focused by "tab press", and add it when focused by "mouse click".
	 *
	 * - Add class "outline_none" to remove "outline" style from element when an element is focused by a mouse-click operation.
	 * - And, when another element or area is clicked, remove "outline" from the previously clicked element.
	 *
	 * - Remove all of "outline" when "tab" is pressed.
	 */
	( function () {

		// Set variable for a previously clicked element.
		var prevElem;

		/* ----- In order to add class "outline_none" to remove "outline" style. ---------- */

		// Use "mousedown" instead of "click" so that the event is no longer triggered when "Enter" key is pressed.
		window.addEventListener( "mousedown", function(e){

			var eventType = e.type;

			var eventTartet = e.target;

			// Remove "outline" from the previously clicked element when another element or area is clicked.
			if ( prevElem ){

				// If the clicked element is different from the previously clicked element.....
				if ( eventTartet !== prevElem ) {

					// If there is, remove class "outline_none" from the previously clicked element.
					prevElem.classList.remove( "outline_none" );

					// If there is, remove it from the keyboard accessible element which is the previously clicked element's closest anscestor.
					var kybdAcssElem_prev = prevElem.closest( QUERY_STR_FOR_KYBD_ACSS_ELEMS );
					if ( kybdAcssElem_prev ) {
						kybdAcssElem_prev.classList.remove( "outline_none" );
					}
				}
			}

			// Set the newly clicked element as the previously clicked element for the next click.
			prevElem = eventTartet;

			// Check if the clicked element is a keyboard accessible element. If not, it should have a keyboard accessible anscestor.
			var isKybdAcss = false;

			// Refer to const "QUERY_STR_FOR_KYBD_ACSS_ELEMS".
			if (
				( "A"        === eventTartet &&   eventTartet.getAttribute( "href"     ) ) ||
				( "BUTTON"   === eventTartet && ! eventTartet.getAttribute( "disabled" ) ) ||
				( "SELECT"   === eventTartet && ! eventTartet.getAttribute( "disabled" ) ) ||
				( "TEXTAREA" === eventTartet && ! eventTartet.getAttribute( "disabled" ) ) ||
				(
					"INPUT" === eventTartet                            &&
					! eventTartet.getAttribute( "disabled" )           &&
					"hidden" !== eventTartet.getAttribute( "type" )                      ) ||
				(
					eventTartet.getAttribute( "tabindex" )             &&
					"-1" !== eventTartet.getAttribute( "tabindex" )                      ) ||
				(
					eventTartet.classList.contains( "focusable_elem" ) &&
					! eventTartet.getAttribute( "disabled" )           &&
					eventTartet.getAttribute( "tabindex" )             &&
					"-1" !== eventTartet.getAttribute( "tabindex" )                      )
			) {
				isKybdAcss = true;
			}

			if ( true === isKybdAcss ) {
				eventTartet.classList.add( "outline_none" );

			} else {
				// Add "outline_none" to the closest keyboard accessible anscestor.
				var kybdAcssElem = eventTartet.closest( QUERY_STR_FOR_KYBD_ACSS_ELEMS );
				if ( kybdAcssElem ) {
					kybdAcssElem.classList.add( "outline_none" );
				}
			}
		});

		/* ----- In order to remove all of "outline" when "tab" is pressed. --------------- */
		window.addEventListener( "keydown", function(e){

			var elems_class_outline_none = document.getElementsByClassName( "outline_none" );

			var elemsLength = elems_class_outline_none.length;
			if ( 0 < elemsLength ) {
				for ( var i = 0; i < elemsLength; i++ ) {
					elems_class_outline_none[i].classList.remove( "outline_none" );
				}
			}
		});

	} () );



	/**
	 * ==================================================================================================================================
	 * Trap focus inside the modal as long as the modal is open.
	 */

		/* ===== Trap focus inside dropdown menus, such as comments list, .... ================== */
		TantyyellowMainJSModule.trap_focus_inside_modal( headerNavLeftSidebar, "nav-expanded"                      , QUERY_STR_FOR_KYBD_ACSS_ELEMS );
		TantyyellowMainJSModule.trap_focus_inside_modal( widgetsRightSidebar , "sidebar-widgets-rightside-expanded", QUERY_STR_FOR_KYBD_ACSS_ELEMS );

		var postAllCats = document.getElementById( "each-post-content-single-meta-cats" );
		var postAllTags = document.getElementById( "each-post-content-single-meta-tags" );
		TantyyellowMainJSModule.trap_focus_inside_modal( postAllCats, "each-post-content-single-meta-cats-expanded", QUERY_STR_FOR_KYBD_ACSS_ELEMS );
		TantyyellowMainJSModule.trap_focus_inside_modal( postAllTags, "each-post-content-single-meta-tags-expanded", QUERY_STR_FOR_KYBD_ACSS_ELEMS );

		TantyyellowMainJSModule.trap_focus_inside_modal( eachPostRelatedPostsList, "each-post-related-posts-expanded", QUERY_STR_FOR_KYBD_ACSS_ELEMS );
		TantyyellowMainJSModule.trap_focus_inside_modal( eachPostCommentsList    , "comments-list-expanded"          , QUERY_STR_FOR_KYBD_ACSS_ELEMS );
		TantyyellowMainJSModule.trap_focus_inside_modal( eachPostPingsList       , "pings-list-expanded"             , QUERY_STR_FOR_KYBD_ACSS_ELEMS );

	( function () {

		/* ===== Trap focus inside each dropdown in "Header Nav Menu". ========================== */
		var kyBdAcssElem1st;
		var kyBdAcssElemEnd;
		var kyBdAcssElem1st_gChildExcluded;
		var kyBdAcssElemEnd_gChildExcluded;

		var focus_1st_keyboard_accessible_elem_depth0;
		var focus_final_keyboard_accessible_elem_depth0;
		var focus_1st_keyboard_accessible_elem_depth1;
		var focus_final_keyboard_accessible_elem_depth1;

		/* ----- Add "keydown" event listener for "Header Nav Menu". ---------------------- */
		document.addEventListener( "keydown", function(e){

			// If the pressed key is not "Enter" or "Enter + shift/ctrl/alt".....
			if ( "Enter" !== e.key || ( "Enter" === e.key && ( true === e.shiftKey || true === e.ctrlKey || true === e.altKey ) ) ) {
				return false;
			}

			var eventTarget       = e.target;
			var eventTargetParent = eventTarget.parentElement;

			// If <a>(key-pressed element) is in the "Header Nav List" & if it has <ul>(dropdown menu) as its sibming.....
			if( headerNavList.contains( eventTarget ) && eventTargetParent.classList.contains( "menu-item-has-children" ) ) {

				// Get all keyboard accessible elements including <a>(key-pressed element) under <li class="menu-item-has-children">.
				var eventTargetKyBdAcssElems = eventTargetParent.querySelectorAll( QUERY_STR_FOR_KYBD_ACSS_ELEMS );


				/* ----- If top-level menu is active, 2nd-level menu shouldn't be focused. -------- */

				// If <li class="menu-item-has-children"> is a top-level menu item.....
				if ( eventTargetParent.classList.contains( "menu-item-depth-0" ) ) {

					// Initialize a new array in order to store only direct child elements and exclude grandchild elements.
					var eventTargetKyBdAcssElems_gChildExcluded = [];

					// Check every keyboard accessible element under <li class="menu-item-has-children"> and exclude grandchild elements.
					for ( var i = 0, len = eventTargetKyBdAcssElems.length; i < len; i++ ) {

						var eventTargetKyBdAcssElem       = eventTargetKyBdAcssElems[i];
						var eventTargetKyBdAcssElemParent = eventTargetKyBdAcssElem.parentElement;

						// If the parent element has a class named "menu-item-depth-1" or "menu-item-depth-0" & if its tag is <li>.....
						if (
							( "LI" === eventTargetKyBdAcssElemParent.tagName ) &&
							( eventTargetKyBdAcssElemParent.classList.contains( "menu-item-depth-1" ) || eventTargetKyBdAcssElemParent.classList.contains( "menu-item-depth-0" ) )
						) {
							eventTargetKyBdAcssElems_gChildExcluded.push( eventTargetKyBdAcssElem );
						}
					}

					// Get the 1st & last keyboard accessible element in the key-pressed menu item.
					kyBdAcssElem1st_gChildExcluded = eventTargetKyBdAcssElems_gChildExcluded[0];
					kyBdAcssElemEnd_gChildExcluded = eventTargetKyBdAcssElems_gChildExcluded[eventTargetKyBdAcssElems_gChildExcluded.length - 1];

					// If the dropdown menu of the targeted menu item is closed when key-pressed.....
					if ( ! eventTargetParent.classList.contains( "show" ) ) {

						// Firstly, remove existing "keydown" event listeners before adding new ones.
						if ( kyBdAcssElem1st_gChildExcluded ) {
							kyBdAcssElem1st_gChildExcluded.removeEventListener( "keydown", focus_final_keyboard_accessible_elem_depth0 );
						}
						if ( kyBdAcssElemEnd_gChildExcluded ) {
							kyBdAcssElemEnd_gChildExcluded.removeEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth0 );
						}

						/* ----- Functions to be able to be removed by "removeEventListener" -------------- */

						// Focus the last keyboard accessible element.
						focus_final_keyboard_accessible_elem_depth0 = function(e){
							// If the pressed key is not "Tab".....
							if ( "Tab" !== e.key ) {
								return;
							}
							// If "shift" key is pressed with "tab".....
							if ( e.shiftKey ) {
								kyBdAcssElemEnd_gChildExcluded.focus();
								e.preventDefault();
							}
						}

						// Focus the first keyboard accessible element.
						focus_1st_keyboard_accessible_elem_depth0 = function(e){
							if ( "Tab" !== e.key ) {
								return;
							}
							// If "tab" key is pressed.....
							if ( ! e.shiftKey ) {
								kyBdAcssElem1st_gChildExcluded.focus();
								e.preventDefault();
							}
						}

						// Secondly, add new "keydown" event listeners in order to trap focus inside the event-targeted top-level menu item.
						if ( kyBdAcssElem1st_gChildExcluded ) {
							kyBdAcssElem1st_gChildExcluded.addEventListener( "keydown", focus_final_keyboard_accessible_elem_depth0 );
						}
						if ( kyBdAcssElemEnd_gChildExcluded ) {
							kyBdAcssElemEnd_gChildExcluded.addEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth0 );
						}

					// If the dropdown menu of the targeted menu item is open when key-pressed.....
					} else {

						// Remove all "keydown" event listeners added to the 1st & last elements of "eventTargetKyBdAcssElems_gChildExcluded".
						if ( kyBdAcssElem1st_gChildExcluded ) {
							kyBdAcssElem1st_gChildExcluded.removeEventListener( "keydown", focus_final_keyboard_accessible_elem_depth0 );
						}
						if ( kyBdAcssElemEnd_gChildExcluded ) {
							kyBdAcssElemEnd_gChildExcluded.removeEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth0 );
						}
					}


				/* ----- If 2nd-level menu is active, top-level menu shouldn't be focused. -------- */

				// If <li class="menu-item-has-children"> is a 2nd-level menu item.....
				} else if ( eventTargetParent.classList.contains( "menu-item-depth-1" ) ) {

					// Get the 1st & last keyboard accessible element in the key-pressed menu item.
					kyBdAcssElem1st = eventTargetKyBdAcssElems[0];
					kyBdAcssElemEnd = eventTargetKyBdAcssElems[eventTargetKyBdAcssElems.length - 1];

					// If the dropdown menu of the targeted menu item is closed when key-pressed.....
					if ( ! eventTargetParent.classList.contains( "show" ) ) {

						/* ----- Functions to be able to be removed by "removeEventListener" -------------- */

						// Focus the last keyboard accessible element.
						focus_final_keyboard_accessible_elem_depth1 = function(e){
							if ( "Tab" !== e.key ) {
								return;
							}
							if ( e.shiftKey ) {
								kyBdAcssElemEnd.focus();
								e.preventDefault();
							}
						}

						// Focus the first keyboard accessible element.
						focus_1st_keyboard_accessible_elem_depth1 = function(e){
							if ( "Tab" !== e.key ) {
								return;
							}
							if ( ! e.shiftKey ) {
								kyBdAcssElem1st.focus();
								e.preventDefault();
							}
						}

						// Remove all "keydown" event listeners added to the 1st & last elements of "eventTargetKyBdAcssElems_gChildExcluded".
						if ( kyBdAcssElem1st_gChildExcluded ) {
							kyBdAcssElem1st_gChildExcluded.removeEventListener( "keydown", focus_final_keyboard_accessible_elem_depth0 );
						}
						if ( kyBdAcssElemEnd_gChildExcluded ) {
							kyBdAcssElemEnd_gChildExcluded.removeEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth0 );
						}

						// Add "keydown" event listeners in order to trap focus inside the event-targeted 2nd-level menu item.
						if ( kyBdAcssElem1st ) {
							kyBdAcssElem1st.addEventListener( "keydown", focus_final_keyboard_accessible_elem_depth1 );
						}
						if ( kyBdAcssElemEnd ) {
							kyBdAcssElemEnd.addEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth1 );
						}

					// If the dropdown menu of the targeted menu item is open when key-pressed.
					} else {

						// Remove all "keydown" event listeners added to the 1st & last elements of "eventTargetKyBdAcssElems".
						if ( kyBdAcssElem1st ) {
							kyBdAcssElem1st.removeEventListener( "keydown", focus_final_keyboard_accessible_elem_depth1 );
						}
						if ( kyBdAcssElemEnd ) {
							kyBdAcssElemEnd.removeEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth1 );
						}

						// Add "keydown" event listeners in order to trap focus inside the event-targeted top-level menu item.
						if ( kyBdAcssElem1st_gChildExcluded ) {
							kyBdAcssElem1st_gChildExcluded.addEventListener( "keydown", focus_final_keyboard_accessible_elem_depth0 );
						}
						if ( kyBdAcssElemEnd_gChildExcluded ) {
							kyBdAcssElemEnd_gChildExcluded.addEventListener( "keydown", focus_1st_keyboard_accessible_elem_depth0 );
						}
					}

				}

			} // End of "if( headerNavList.contains( eventTarget ) && eventTargetParent.classList.contains( "menu-item-has-children" ) )".

		}); // End of "document.addEventListener( "keydown" ).

	} () );



	/* ===== Adjust(Keep) the <iframe>'s width & height ratio =================================== */
	( function () {

		var timerID_resizeEvent = null;

		window.addEventListener( "load"  , fix_embedded_iframe_ratio );
		window.addEventListener( "resize", function(){
			clearTimeout( timerID_resizeEvent );
			timerID_resizeEvent = setTimeout( function() {
				fix_embedded_iframe_ratio();
			}, 500 );
		});

		function fix_embedded_iframe_ratio() {

			/**
			 * Keep <iframe> ratio of the width & height constant.
			 *
			 * @see \wp-includes\class-wp-oembed.php
			 *
			 * @link https://wordpress.org/support/article/embeds/
			 */

			// If the <iframe> includes one of these keywords, it is necessary to adjust its size manually to keep the ratio.
			var regExp_need_adjustIframe = /(cloudup\.com|dailymotion\.com|dai\.ly|hulu\.com|issuu\.com|kickstarter\.com|kck\.st|loom\.com|screencast\.com|scribd\.com|speakerdeck\.com|slideshare\.net|ted\.com|vimeo\.com|video\.WordPress\.com\/embed|WordPress\.tv|youtube\.com\/embed|youtube\.com\/playlist|youtube\.com\/watch|youtu\.be)/;

			var iframes = document.getElementsByTagName( "iframe" );

			if ( iframes ) {
				for( var i = 0, len = iframes.length; i < len; i++ ) {

					var iframe       = iframes[i];
					var iframeParent = iframe.parentElement;

					// Check if the <iframe> src attribute includes the keyword to adjust the ratio by checking "regExp_need_adjustIframe".
					if ( regExp_need_adjustIframe.test( iframe.getAttribute( "src" ) ) === true ) {

						// Get the "width" & "height" attributes the <iframe> originally has.
						var iframeAttrW = iframe.getAttribute( "width" );
						var iframeAttrH = iframe.getAttribute( "height" );

						// Get the Get the "width" & "height" by retrieving the <iframe>'s DOMRect object.
						var iframeRect = iframe.getBoundingClientRect();

						var iframeRatio;

						// Confirm the <iframe>'s original ratio.
						if ( iframeAttrW && iframeAttrH ) {
							// If the iframe element has both "width" & "height" attributes, calculate ratio from them.
							iframeRatio = iframeAttrH / iframeAttrW;

						} else {
							// Calculate ratio from element's initial sizes when the window is loaded.
							iframeRatio = iframeRect["height"] / iframeRect["width"];
						}

						// If the height is too long compared to the width.....
						iframeRatio = ( 2 > iframeRatio ) ? iframeRatio : 1;

						// If the <iframe> is embedded by using the Gutenberg editor's "Embeds Block" function.
						if ( iframeParent.classList.contains( "wp-block-embed__wrapper" ) ) {

							var iframeRatioPercent = iframeRatio * 100;

							// CSS styles for the <iframe> in order to keep the iframe's width & height ratio.
							iframe.style.setProperty( 'position', 'absolute', 'important' );
							iframe.style.setProperty( 'top', '0', 'important' );
							iframe.style.setProperty( 'right', '0', 'important' );
							iframe.style.setProperty( 'width', '100%', 'important' );
							iframe.style.setProperty( 'height', '100%', 'important' );

							// CSS styles for the <iframe>'s parent in order to keep the iframe's width & height ratio.
							iframeParent.style.setProperty( 'position', 'relative', 'important' );
							iframeParent.style.setProperty( 'width', '100%', 'important' );
							iframeParent.style.setProperty( 'height', '100%', 'important' );
							iframeParent.style.setProperty('padding-top', iframeRatioPercent + "%", 'important' );
							iframeParent.style.setProperty( 'padding-bottom', 'unset', 'important' );

						} else {

							iframe.setAttribute( "width" , iframeRect["width"] );
							var iframeWidth  = iframeRect["width"];
							var iframeHeight = iframeWidth * iframeRatio;

							iframe.setAttribute( "width" , iframeWidth );
							iframe.setAttribute( "height", iframeHeight );
						}
					}
				}
			}
		}
	} () );



	/* ===== Adjust(Keep) the iframe's width & height ratio ===================================== */
	var alignLefts  = document.getElementsByClassName( "alignleft" );
	var alignRights = document.getElementsByClassName( "alignright" );

	if ( alignLefts ) {
		for ( var i = 0, len = alignLefts.length; i < len; i++ ) {
			alignLefts[i].parentElement.classList.add( "clearfix" );
		}
	}

	if ( alignRights ) {
		for ( var i = 0, len = alignRights.length; i < len; i++ ) {
			alignRights[i].parentElement.classList.add( "clearfix" );
		}
	}



	/* ===== Event listeners to update values of "tabindex" ===================================== */
	/* ===== for keyboard accessible elements in the header navigation. ========================= */
	var navLeftToggleBtn = document.getElementById( "header-nav-toggle-btn" );

	/* ----- 01. When window is loaded,..... ------------------------------------------ */
	window.addEventListener( "load", function(){

		/* ..... When the header navigation is on the left ( not top )..... ......... */
		if ( ! ( BREAKPOINT_PC_TABLET < window.innerWidth ) ) {
			// Set attribute 'tabindex' for all keyboard accessible elements to '-1'.
			for ( var i = 0, len = headerNavLeftSidebarKyBdAcssElems.length; i < len; i++ ) {
				headerNavLeftSidebarKyBdAcssElems[i].setAttribute( "tabindex", "-1" );
			}
			// After setting attribute 'tabindex' for all to "-1", set it for the header nav burger button to "0".
			document.getElementById( "header-nav-toggle-btn" ).setAttribute( "tabindex", "0" );
		} else {
			for ( var i = 0, len = headerNavLeftSidebarKyBdAcssElems.length; i < len; i++ ) {
				headerNavLeftSidebarKyBdAcssElems[i].setAttribute( "tabindex", "0" );
			}
		}
	});

	/* ----- 02. When window is resized,..... ----------------------------------------- */
	( function () {

		// IE9+, Other Browsers
		try {
			window.addEventListener( 'resize', func_timer, false );

		//for IE8-
		} catch (e) {
			window.attachEvent( 'onresize', func_timer );
		}

		var timerId = null;

		function func_timer(){
			clearTimeout( timerId );
			timerId = setTimeout( func_update_tabindex, 300 );
		}

		function func_update_tabindex(){

			/* ..... When the header navigation is at the top..... .................. */
			if ( BREAKPOINT_PC_TABLET < window.innerWidth ) {
				// Remove attribute 'tabindex' for all keyboard accessible elements.
				for ( var i = 0, len = headerNavLeftSidebarKyBdAcssElems.length; i < len; i++ ) {
					headerNavLeftSidebarKyBdAcssElems[i].setAttribute( "tabindex", "0" );
				}
				// Remove class "header-nav-leftside-expanded" from <div id="site">
					site.classList.remove( "header-nav-leftside-expanded" );
				// Remove class "nav-expanded" from <nav id="header-nav-sidebar-wrapper">
					headerNavLeftSidebar.classList.remove( "nav-expanded" );

			/* ..... When the header navigation is on the left side..... ............ */
			} else {
				// Set attribute 'tabindex' for all keyboard accessible elements to '-1'.
				for ( var i = 0, len = headerNavLeftSidebarKyBdAcssElems.length; i < len; i++ ) {
					headerNavLeftSidebarKyBdAcssElems[i].setAttribute( "tabindex", "-1" );
				}
				// After setting attribute 'tabindex' for all to "-1", set it for the header nav burger button to "0".
				document.getElementById( "header-nav-toggle-btn" ).setAttribute( "tabindex", "0" );
			}
		}
	} () );

	/* ----- 03. When the header nav left burger button is clicked, ------------------- */
	navLeftToggleBtn.addEventListener( "click", function(){

		/* ..... When the header nav left menu is expanded..... ................. */
		if ( site.classList.contains( "header-nav-leftside-expanded" ) ) {
			// Remove class "header-nav-leftside-expanded" from <div id="site">.
			site.classList.remove( "header-nav-leftside-expanded" );
			// Remove class "nav-expanded" from <nav id="header-nav-sidebar-wrapper">.
			headerNavLeftSidebar.classList.remove( "nav-expanded" );

			// Set 'tabindex' attribute to '-1' ( meaning not keyboard accessible ).
			for ( var i = 0, len = headerNavLeftSidebarKyBdAcssElems.length; i < len; i++ ) {
				// Set attribute 'tabindex' for all keyboard accessible elements to '-1'.
				headerNavLeftSidebarKyBdAcssElems[i].setAttribute( "tabindex", "-1" );
			}
			// After setting attribute 'tabindex' for all to "-1", set it for the header nav burger button to "0".
			document.getElementById( "header-nav-toggle-btn" ).setAttribute( "tabindex", "0" );

		/* ..... When the header nav left menu is collapsed..... ................ */
		} else {
			// Add class 'header-nav-leftside-expanded' to <div id="site">.
			site.classList.add( "header-nav-leftside-expanded" );
			// Add class "nav-expanded" to <nav id="header-nav-sidebar-wrapper">.
			headerNavLeftSidebar.classList.add( "nav-expanded" );
			// Set attribute 'tabindex' for all keyboard accessible elements to "0".
			for ( var i = 0, len = headerNavLeftSidebarKyBdAcssElems.length; i < len; i++ ) {
				headerNavLeftSidebarKyBdAcssElems[i].setAttribute( "tabindex", "0" );
			}
		}
	});



	/* ************************************************************************************************************** */
	/* ***** Header ************************************************************************************************* */
	/* ************************************************************************************************************** */

	/**
	 * ==================================================================================================================================
	 * Modify the style of the header nav's 2nd dropdown menu <ul> if it overflows the window
	 * vertically when it is expanded so that the dropdown menu should be within the window.
	 */
	( function () {

		var INTERVAL_DURATION   = 10;  // How frequently to check if the clicked dropdown is expanded.
		var INTERVAL_RECURRENCE = 20;  // How many times the interval should reccur.

		// This will be <ul class="menu-item-depth-1"> overlowing the window. ( there is CSS styles in "_template_header.scss" ).
		var CLASS_DROPDOWN_OVERFLOWING = "header_nav_dropdown_overflows_window_vertically";

		// This will be used to identify the <style> to be used to style the overflew dropdown menu <ul class="menu-item-depth-1">.
		var STYLE_TAG_ID = "tantyyellow_style_tag_for_header_nav_dropdown_menu";

		// IDs for "setInterval()".
		var intervalID_monitor_isDropdownExpanded = null;

		// <a class="main-menu-link"> clicked the most recently.
		var currMainMenuAnchor;

		// Flag to determine if monitoring & modifying Header Nav's overflow is necessary or not.
		var need_monitoring_overflow = false;

		// Need monitoring & modifying when the Window is resized.
		window.addEventListener( "resize", function(){
			need_monitoring_overflow = true;
		});

		if ( headerNavList ) {

			// Get all <a class="main-menu-link"> inside the header navigation menu.
			var mainMenuAnchors = headerNavList.getElementsByClassName( "main-menu-link" );

			if ( mainMenuAnchors ) {

				var mainMenuAnchors_len = mainMenuAnchors.length;

				for ( var i = 0; i < mainMenuAnchors_len; i++ ) {

					var mainMenuAnchor     = mainMenuAnchors[i];
					var mainMenuDropdownUl = mainMenuAnchor.nextElementSibling;

					if ( mainMenuDropdownUl ) {

						var mainMenuLi        = mainMenuAnchor.parentElement;
						var mainMenuLiClasses = mainMenuLi.classList;

						// If the menu <li> is a top level menu & has a dropdown menu.....
						if ( mainMenuLiClasses.contains( "menu-item-depth-0" ) && mainMenuLiClasses.contains( "menu-item-has-children" ) ) {

							/**
							 * When the Header Nav's menu item having dropdown menu is clicked or focused by "Tab" key,...
							 * - Opening menu by "Tab" key's operation is a mandatory requirement.
							 * - Otherwise, the theme cannot be approved as the official "WordPress.org" theme.
							 */
							mainMenuAnchor.addEventListener( "click", function(){
								modify_header_nav_overflowing_dropdown_menu( this );
							});
							mainMenuAnchor.addEventListener( "keyup", function(e){
								if ( "Tab" === e.key ) {
									this.click();
								}
							});



							function modify_header_nav_overflowing_dropdown_menu( _this ) {

								// console.log( "**********************************************************************" );
								// console.log( "modify_header_nav_overflowing_dropdown_menu() is executed!!!" );
								// console.log( "**********************************************************************" );

								clearInterval( intervalID_monitor_isDropdownExpanded );

								// Store "this" in the variable as an alias.
								var mainMenuAnchorAlias     = _this;
								var mainMenuDropdownUlAlias = mainMenuAnchorAlias.nextElementSibling;

								// If the clicked <a class="main-menu-link"> is not <a> which was clicked last time.
								if ( mainMenuAnchorAlias !== currMainMenuAnchor ) {

									need_monitoring_overflow = true;

									// Set the clicked <a class="main-menu-link"> in the variable "currMainMenuAnchor".
									currMainMenuAnchor = mainMenuAnchorAlias;
								}



								// If the variable "need_monitoring_overflow" is true,...
								if ( true === need_monitoring_overflow ) {

									need_monitoring_overflow = false;

									// Reset: remove a class & remove <style> in <head> to style overflowing dropdown.
									mainMenuDropdownUlAlias.classList.remove( CLASS_DROPDOWN_OVERFLOWING );
									mainMenuDropdownUlAlias.classList.remove( "clearfix" );
									remove_current_style_tag_in_head( STYLE_TAG_ID );

									var isDropdownExpanded;

									var counter = 0;
									// Check if the dropdown is expanded certain times ( INTERVAL_RECURRENCE ).
									intervalID_monitor_isDropdownExpanded = setInterval( function() {
										counter++;

										isDropdownExpanded = check_if_dropdown_is_expanded( mainMenuAnchorAlias );

										// If detecting the expansion of the dropdown,...
										if ( true === isDropdownExpanded ) {
											clearInterval( intervalID_monitor_isDropdownExpanded );
											monitor_dropdown_vertical_overflow( mainMenuAnchorAlias );
											return;
										}

										// After certain times, clear the interval.
										if ( INTERVAL_RECURRENCE <= counter ) {
											clearInterval( intervalID_monitor_isDropdownExpanded );
											return;
										}


									}, INTERVAL_DURATION );
								} // End of "if ( true === need_monitoring_overflow )".
							} // End of the function "modify_header_nav_overflowing_dropdown_menu()".
						} // End of "if ( mainMenuLiClasses.contains( "menu-item-depth-0" ) && mainMenuLiClasses.contains( "menu-item-has-children" ) )".
					} // End of "if ( mainMenuDropdownUl )".
				}
			} // End of "if ( mainMenuAnchors )".
		}


		/* ===== Functions to be used for above operation. ========================================== */

			/* ----- Monitor if the clicked dropdown overflows for a certain amount of time. -- */
			function monitor_dropdown_vertical_overflow( _menu_anchor ) {

				var counter_1 = 0;
				// Check if the dropdown will / does overflow the window certain times ( INTERVAL_RECURRENCE ).
				var intervalID_1 = setInterval( function() {
					counter_1++;

					var doesDropdownOverflow = check_if_dropdown_does_overflow_window_bottom( _menu_anchor );

					// When detecting the dropdown overflowing, start fixing execution.
					if ( true === doesDropdownOverflow ) {
						clearInterval( intervalID_1 );
						fix_dropdown_horizontal_overflow( _menu_anchor, "right" );

						var counter_2 = 0;
						// Check if the dropdown will / does still overflow the window certain times ( INTERVAL_RECURRENCE ).
						var intervalID_2 = setInterval( function(){
							counter_2++;

							var doesDropdownOverflow2 = check_if_dropdown_does_overflow_window_bottom( _menu_anchor );

							if ( true === doesDropdownOverflow2 ) {
								clearInterval( intervalID_2 );
								fix_dropdown_horizontal_overflow( _menu_anchor, "left" );

								var counter_3 = 0;
								// Check if the dropdown will / does still overflow the window certain times ( INTERVAL_RECURRENCE ).
								var intervalID_3 = setInterval( function(){
									counter_3++;

									var doesDropdownOverflow3 = check_if_dropdown_does_overflow_window_bottom( _menu_anchor );

									if ( true === doesDropdownOverflow3 ) {
										clearInterval( intervalID_3 );
										fix_dropdown_horizontal_overflow( _menu_anchor, "full" );
										return;
									}

									// After certain times, clear the interval.
									if( INTERVAL_RECURRENCE <= counter_3 ) {
										clearInterval( intervalID_3 );
										return;
									}

								}, INTERVAL_DURATION );

							}

							// After certain times, clear the interval.
							if ( INTERVAL_RECURRENCE <= counter_2 ) {
								clearInterval( intervalID_2 );
								return;
							}

						}, INTERVAL_DURATION );

					}

					// After certain times, clear the interval.
					if( INTERVAL_RECURRENCE <= counter_1 ) {
						clearInterval( intervalID_1 );
						return;
					}

				}, INTERVAL_DURATION );

			}

			/* ----- Fix the clicked dropdown overflowing the window's bottom vertically. ----- */
			function fix_dropdown_horizontal_overflow( _menu_anchor, _which_side_to_fix = "right" ) {

				var _mainMenu_dropdown_Ul = _menu_anchor.nextElementSibling;

				// Firstly, if there is, remove the existing <style> in <head> for styling the dropdown menu.
				remove_current_style_tag_in_head( STYLE_TAG_ID );

				// Secondly, add class to the dropdown <ul> in order to style it and the child <li> items.
				_mainMenu_dropdown_Ul.classList.add( CLASS_DROPDOWN_OVERFLOWING );
				_mainMenu_dropdown_Ul.classList.add( "clearfix" );

				// Thirdly, add a new <style> into <head>.
				add_new_style_tag_in_head( STYLE_TAG_ID );

				// Finally, add CSS rules into the above created <style> in <head>.

				var windowWidth    = window.innerWidth;
				var menuAnchorRect = _menu_anchor.getBoundingClientRect();

				var dropdownSideMargin = 20;
				var cssSelector        = ( "." + CLASS_DROPDOWN_OVERFLOWING );
				var arrCssPropValueSets;

				if ( "right" === _which_side_to_fix ) {
					var dropdownWidthFixed = ( ( windowWidth - menuAnchorRect["left"] ) - dropdownSideMargin ) + "px";
					arrCssPropValueSets    = [
						["position", "fixed"                                    , true],
						["top"     , ( ( menuAnchorRect["bottom"] ) + "px" )    , true],
						["left"    , ( ( menuAnchorRect["left"] - 7 ) + "px" )  , true],
						["right"   , ( dropdownSideMargin + "px" )              , true],
						["width"   , ( dropdownWidthFixed + "px" )              , true]
					];

				} else if ( "left" === _which_side_to_fix ) {
					var dropdownWidthFixed  = ( menuAnchorRect["right"] - dropdownSideMargin ) + "px";
					arrCssPropValueSets = [
						["position", "fixed"                                                  , true],
						["top"     , ( ( menuAnchorRect["bottom"] ) + "px" )                  , true],
						["left"    , ( dropdownSideMargin + "px" )                            , true],
						["right"   , ( ( windowWidth - menuAnchorRect["right"] - 17 ) + "px" ), true],
						["width"   , ( dropdownWidthFixed + "px" )                            , true]
					];

				} else if ( "full" === _which_side_to_fix ) {
					arrCssPropValueSets    = [
						["position", "fixed"                                            , true],
						["top"     , ( ( menuAnchorRect["bottom"] ) + "px" )            , true],
						["left"    , ( dropdownSideMargin + "px" )                      , true],
						["right"   , ( dropdownSideMargin + "px" )                      , true],
						["width"   , "calc(100% - " + ( dropdownSideMargin * 2 ) + "px)", true]
					];
				}

				var newCSSRulesArr = [ [ cssSelector, arrCssPropValueSets ] ];

				add_new_css_rules_into_existing_style_tag_in_head( STYLE_TAG_ID, newCSSRulesArr );

				// clearInterval( intervalID_monitor_doesDropdownOverflow );
			}



			/* ----- Check if the dropdown menu is expanded. ---------------------------------- */
			function check_if_dropdown_is_expanded( _menu_anchor ) {
				var is_expanded = false;
				if ( "dropdown" === _menu_anchor.getAttribute( "data-toggle" ) ) {
					if ( "true" === _menu_anchor.getAttribute( "aria-expanded" ) ) {
						is_expanded = true;
					}
				}
				return is_expanded;
			}

			/* ----- Check if the dropdown menu exceeds the window vertically. ---------------- */
			function check_if_dropdown_does_overflow_window_bottom( _menu_anchor ) {
				var does_overflow = false;

				var dropdown = _menu_anchor.nextElementSibling;

				// Get the overflowing dropdown DOMRect object(providing info about the size & position) at this very moment.
				var dropdownRect = dropdown.getBoundingClientRect();

				// If the dropdown menu overflows the window vertically.....
				if ( window.innerHeight < dropdownRect["bottom"] ) {
					does_overflow = true;
				}

				return does_overflow;
			}

			/* ----- Function to remove <style> from <head> based on "id" <style> has. -------- */
			function remove_current_style_tag_in_head( _target_style_tag_id ) {

				var currStyleTag = document.getElementById( _target_style_tag_id );

				// If <style id="_tag_id"> exists in <head>, remove it.
				if ( currStyleTag && "STYLE" === currStyleTag.tagName ) {
					currStyleTag.parentNode.removeChild( currStyleTag );
				}
			}

			/* ----- Function to add a new <style> with "id" in <head>.------------------------ */
			function add_new_style_tag_in_head( _new_style_tag_id ) {

				// If there is no <style> in <head> which has an attribute id="_style_tag_id".....
				if ( ! document.getElementById( _new_style_tag_id ) ) {

					// Create a new dom element <style type="text/css" id="_style_tag_id">.
					var newStyleTag  = document.createElement( "style" );
					newStyleTag.type = "text/css";
					newStyleTag.id   = _new_style_tag_id;

					//  Append the created new <style> in <head> as the last child
					document.head.appendChild( newStyleTag );
				}
			}


			/* ----- Get the number of the existing <style> in <head> based on its "id". ------ */
			function get_num_of_existing_style_tag_in_head( _target_style_tag_id ) {

				// Get all existing stylesheets.
				var stylesheetsAll = document.styleSheets;

				// Check if there is a <style> with id "_target_style_tag_id", and if there is, find the number of it.
				var targetStylesheetNum = null;
				for ( var i = 0, len = stylesheetsAll.length; i < len; i++ ) {
					if ( _target_style_tag_id === stylesheetsAll[i].ownerNode.id ) { // https://developer.mozilla.org/ja/docs/Web/API/StyleSheet/ownerNode
						targetStylesheetNum = i;
						break;
					}
				}

				return targetStylesheetNum;
			}

			/**
			 * ----- Function to add new css rule to <style> in head by specifing its "id". ---
			 *
			 * var cssRules = [
					[ "selector0", [ ["property0_0", "value0_0", true], ["property0_1", "value0_1", true], ["property0_2", "value0_2", true] ] ],
					[ "selector1", [ ["property1_0", "value1_0", true], ["property1_1", "value1_1", true], ["property1_2", "value1_2", true] ] ]
				];
			*
			* - cssRules[n][0]       : [depth] (0)"nth" CSS rule ==> (1)"Selector".
			* - cssRules[n][1]       : [depth] (0)"nth" CSS rule ==> (1)"property & value" sets.
			* - cssRules[n][1][m]    : [depth] (0)"nth" CSS rule ==> (1)"property & value" sets ==> (2)"mth property & value" set.
			* - cssRules[n][1][m][0] : [depth] (0)"nth" CSS rule ==> (1)"property & value" sets ==> (2)"mth property & value" set ==> (3)"property".
			* - cssRules[n][1][m][1] : [depth] (0)"nth" CSS rule ==> (1)"property & value" sets ==> (2)"mth property & value" set ==> (3)"value".
			*
			* - The 3rd argument "true" for "!important".
			*/
			function add_new_css_rules_into_existing_style_tag_in_head( _target_style_tag_id, _array_new_css_rules ) {

				var targetStylesheet;

				var targetStylesheetNum = get_num_of_existing_style_tag_in_head( _target_style_tag_id );

				// If there is no such <style>, freate a new <style> and set it as a target stylesheet to which a new CSS rule will be added.
				if ( null === targetStylesheetNum ) {
					add_new_style_tag_in_head( _target_style_tag_id );
					targetStylesheet = document.styleSheets.item( document.styleSheets.length - 1 );
				// If there is...
				} else {
					targetStylesheet = document.styleSheets.item( targetStylesheetNum );
				}

				for ( var i = 0, len = _array_new_css_rules.length; i < len; i++ ) {

					if ( "undefined" !== typeof ( _array_new_css_rules[i] ) ) {

						var eachCssRule = _array_new_css_rules[i];

						var selector    = eachCssRule[0];
						var stylesStr   = "";

						var propValueSets = eachCssRule[1];

						for ( var j = 0, len = propValueSets.length; j < len; j++ ) {
							var propValueSet = propValueSets[j];
							var property     = propValueSet[0];
							var value        = propValueSet[1];
							var important    = propValueSet[2]; // trule if set.
							stylesStr += "\n" + property + ": " + value + ( important ? " !important" : "" ) + ";"; // Set of "property: value !important;".
						}

						var cssRuleStr = selector + "{" + stylesStr + "\n}";

						// Insert each new CSS rule at the end of the target stylesheet.
						targetStylesheet.insertRule( cssRuleStr , targetStylesheet.cssRules.length );
					}
				}
			}

	} () );



	/* ===== Determine wheader nav's 2nd dropdown menu should expand to left or right. ========== */
	( function () {

		if ( BREAKPOINT_PC_TABLET < window.innerWidth ) {

			if ( headerNavList ) {

				var subMenuAnchors = headerNavList.getElementsByClassName( "sub-menu-link" );

				if ( subMenuAnchors ) {

					window.addEventListener( "load"  , monitor_2nd_dropdown_vertical_overflow );

					function monitor_2nd_dropdown_vertical_overflow() {

						for ( var i = 0, len = subMenuAnchors.length; i < len; i++ ) {

							var subMenuAnchor       = subMenuAnchors[i];
							var subMenuAnchorParent = subMenuAnchor.parentElement;

							if ( subMenuAnchorParent.classList.contains( "menu-item-has-children" ) ) {

								if ( subMenuAnchorParent.classList.contains( "menu-item-depth-1" ) ) {

									expandDropdownChildMenuLeftOrRight( subMenuAnchor );

									/**
									 * When the Header Nav's menu item having dropdown menu is clicked or focused by "Tab" key,...
									 * - Opening menu by "Tab" key's operation is a mandatory requirement.
									 * - Otherwise, the theme cannot be approved as the official "WordPress.org" theme.
									 */
									subMenuAnchor.addEventListener( "click", function(){
										expandDropdownChildMenuLeftOrRight( this );
									});
									subMenuAnchor.addEventListener( "keyup", function(e){
										if ( "Tab" === e.key ) {
											this.click();
										}
									});




									// For determine the remaining space on the right of the dropdown menu, and if not enough, then expand it to the left.
									// subMenuAnchor.addEventListener( "focus", function(){
									// 	var _funcClick = function () {
									// 		this.removeEventListener( "keyup", _funcKeyup, { once: true } );
									// 		expandDropdownChildMenuLeftOrRight(this);
									// 	};
									// 	var _funcKeyup = function () {
									// 		this.removeEventListener( "click", _funcClick, { once: true } );
									// 		this.click();
									// 		expandDropdownChildMenuLeftOrRight( this );
									// 	};
									// 	this.addEventListener( "click", _funcClick, { once: true } );
									// 	this.addEventListener( "keyup", _funcKeyup, { once: true } );
									// });
								}
							}
						}
					}
				}
			}
		}

		// Expand the 3rd-depth dropdown menu to the left only when there is not enough space on the right of the menu.
		function expandDropdownChildMenuLeftOrRight( elem ) {

			// Get DOMRect object providing info about the size & position of the element.
			var domRect = elem.getBoundingClientRect(); // Ref: https://developer.mozilla.org/en-US/docs/Web/API/Element/getBoundingClientRect

			// Get sizes of the clicked element.
			var windowWidth              = window.innerWidth;
			var elemWidth                = domRect.width; // Width of the element.
			var elemOffsetRight          = domRect.right; // Distance from the window's left edge to the element's right edge.
			var elemOffsetRightFromRight = windowWidth - elemOffsetRight; // Distance from the window's right edge to the element's right edge.

			// If the size from the element's right edge to the window's right edge is not enough to expand a dropdown menu to the right.....
			if ( elemOffsetRightFromRight < ( elemWidth + 120 ) ) {
				elem.parentElement.classList.add( "expand_dropdown_menu_left" );
				elem.parentElement.classList.remove( "expand_dropdown_menu_right" );
			} else {
				elem.parentElement.classList.add( "expand_dropdown_menu_right" );
				elem.parentElement.classList.remove( "expand_dropdown_menu_left" );
			}
		}

	} () );



	/* ************************************************************************************************************** */
	/* ***** Single Post Page *************************************************************************************** */
	/* ************************************************************************************************************** */

	/* ===== In order to make Categories & Tags list in each single page at the bottom foldable = */
	var singleContentEachMetasTitleBtn = document.getElementsByClassName( "each-post-content-single-meta-title" );

	if ( singleContentEachMetasTitleBtn ) {
		for ( var i = 0, len = singleContentEachMetasTitleBtn.length; i < len; i++ ){
			singleContentEachMetasTitleBtn[i].addEventListener( "click", function() {

				var parentDiv = this.parentElement;
				var listItems = this.nextElementSibling.getElementsByTagName( "li" );


				/* ----- Toggle the list of categories/tags when its title is clicked ------------- */
				if ( this === document.getElementById( "each-post-content-single-meta-cats-title" ) ) {
					if ( parentDiv.classList.contains( "each-post-content-single-meta-cats-expanded" ) ) {
						parentDiv.classList.remove( "each-post-content-single-meta-cats-expanded" );

						if ( listItems ) {
							for ( var j = 0, len = listItems.length; j < len; j++ ) {
								var anchor = listItems[j].firstElementChild;
								if ( anchor ) {
									anchor.setAttribute( "tabindex", "-1" );
								}
							}
						}

					} else {
						parentDiv.classList.add( "each-post-content-single-meta-cats-expanded" );

						if ( listItems ) {
							for ( var j = 0, len = listItems.length; j < len; j++ ) {
								var anchor = listItems[j].firstElementChild;
								if ( anchor ) {
									anchor.setAttribute( "tabindex", "0" );
								}
							}
						}
					}

				} else if ( this === document.getElementById( "each-post-content-single-meta-tags-title" ) ) {
					if (parentDiv.classList.contains( "each-post-content-single-meta-tags-expanded" ) ) {
						parentDiv.classList.remove( "each-post-content-single-meta-tags-expanded" );

						if ( listItems ) {
							for ( var j = 0, len = listItems.length; j < len; j++ ) {
								var anchor = listItems[j].firstElementChild;
								if ( anchor ) {
									anchor.setAttribute( "tabindex", "-1" );
								}
							}
						}

					} else {
						parentDiv.classList.add( "each-post-content-single-meta-tags-expanded" );

						if ( listItems ) {
							for ( var j = 0, len = listItems.length; j < len; j++ ) {
								var anchor = listItems[j].firstElementChild;
								if ( anchor ) {
									anchor.setAttribute( "tabindex", "0" );
								}
							}
						}
					}
				}
			});
		}
	}



	/* ===== In order to make Related Posts Content in each single page foldable ================ */
	if ( eachPostRelatedPostsListHeader ) {
		eachPostRelatedPostsListHeader.addEventListener( "click", function(){
			this.parentNode.classList.toggle( "each-post-related-posts-expanded" );
		});
	}



	/* ************************************************************************************************************** */
	/* ***** Commments ********************************************************************************************** */
	/* ************************************************************************************************************** */

	/* ===== In order to make Comments List Content in each single page foldable ================ */
	if ( eachPostCommentsListHeader ) {
		eachPostCommentsListHeader.addEventListener( "click", function(){
			this.parentNode.classList.toggle( "comments-list-expanded" );
		});
	}



	/* ===== In order to make Pingbacks & Trackbacks List Content in each single page foldable == */
	if ( eachPostPingsListHeader ) {
		eachPostPingsListHeader.addEventListener( "click", function(){
			this.parentNode.classList.toggle( "pings-list-expanded" );
	});
	}



	/* ===== Set attribute 'tabindex' for the name of the author who is replied to '-1'. ======== */
	var commentAuthorNameToBeReplied = document.getElementsByClassName( "comment_author_name_to_be_replied" );
	if ( commentAuthorNameToBeReplied ) {
		for ( var i = 0, len = commentAuthorNameToBeReplied.length; i < len; i++ ) {
			commentAuthorNameToBeReplied[i].firstElementChild.setAttribute( "tabindex", "-1" );
		}
	}



	/* ######################################################################################################################## */
	/* ##### End of Pure Javascript ########################################################################################### */
	/* ######################################################################################################################## */





	/* ######################################################################################################################## */
	/* ##### jQuery ########################################################################################################### */
	/* ######################################################################################################################## */

	/* Use 'jQuery' instead of '$' because WordPress default 'jquery.js' is customized with 'noConflict()' */
	/* Reference: https://yatteq.com/need-torun-jquerylibrary/ */



	/* ===== Common variables =================================================================== */
	var $headerNavSidebarWrap                 = jQuery( "#header-nav-sidebar-wrapper" );
	var $headerNavList                        = jQuery( "#header-nav-list" );
	var $contents                             = jQuery( ".contents" );
	var $widgetsSidebar                       = jQuery( ".contents-sidebar" );
	var $widgetsSidebarRightsideBtnWrap       = jQuery( "#sidebar-widgets-rightside-toggle-btn-wrapper" );
	var $widgetsSidebarRightsideBtn           = jQuery( "#sidebar-widgets-rightside-toggle-btn" );
	var $widgetsSidebarRightsideKyBdAcssElems = jQuery( ".contents-sidebar" ).find( QUERY_STR_FOR_KYBD_ACSS_ELEMS );
	var $copyright                            = jQuery( ".copyright" );



	/* ===== SlideUp & slideDown 'Site Main Nav' dropdown menu when clicked ===================== */
	jQuery( ".sidebar-dropdown > a" ).on( "click", function() {
		jQuery( ".sidebar-submenu" ).slideUp( 200 );
		if (
			jQuery( this )
			.parent()
			.hasClass( "active" )
		) {
			jQuery( ".sidebar-dropdown" ).removeClass( "active" );
			jQuery( this )
			.parent()
			.removeClass( "active" );
		} else {
			jQuery( ".sidebar-dropdown" ).removeClass( "active" );
			jQuery( this )
			.next( ".sidebar-submenu" )
			.slideDown( 200 );
			jQuery( this )
			.parent()
			.addClass( "active" );
		}
	});



	/* ===== Disable active element when clicking 'other area' from it ========================== */
	jQuery( document ).on( "click touchend focusin", function(e){

		/* ----- 01. For the pulldowns when 'Site Main Navigation' is at the top ---------- */
		if ( ! jQuery( e.target ).closest( '.active.main-menu-item.sidebar-dropdown.menu-item-has-children' ).length ) {
			jQuery( '.active.main-menu-item.sidebar-dropdown.menu-item-has-children .sidebar-submenu' ).slideUp( 200 );
			jQuery( '.active.main-menu-item.sidebar-dropdown.menu-item-has-children' ).removeClass( "active" );
		}

		/* ----- 02. For the burger menu when 'Site Main Navigation' is on the left ------- */

		// If "Auto-close" setting for "Burger menu" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_left_burger_on" ) ) {
			if ( ! ( BREAKPOINT_PC_TABLET < window.innerWidth ) ) {
				if ( ! jQuery( e.target ).closest( '.nav-expanded' ).length ) {
					jQuery( "#site" ).removeClass( "header-nav-leftside-expanded" );
					$headerNavSidebarWrap.removeClass( "nav-expanded" );
					jQuery( "#header-nav-sidebar-wrapper a, #header-nav-sidebar-wrapper button, #header-nav-sidebar-wrapper input" ).not( "#header-nav-toggle-btn" ).attr( "tabindex", "-1" );
				}
			}
		}

		/* ----- 03. For 'Right Side Widgets Sidebar' ------------------------------------- */

		// If "Auto-close" setting for "Right Side Widgets Sidebar" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_right_widgets_on" ) ) {
			if ( ! jQuery( e.target ).closest( '.sidebar-widgets-rightside-expanded' ).length ) {
				jQuery( ".contents-sidebar" ).removeClass( "sidebar-widgets-rightside-expanded" );
				$contents.addClass( "contents-width-100" );
				$copyright.addClass( "copyright-width-100" );
				$widgetsSidebarRightsideKyBdAcssElems.not( "#sidebar-widgets-rightside-toggle-btn" ).attr( "tabindex", "-1" );
			}
		}

		/* ----- 04. For 'Each Single Post Complete List of Categories' ------------------- */

		// If "Auto-close" setting for "Each Single Post Complete List of Categories" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_single_cats_on" ) ) {
			if ( ! jQuery( e.target ).closest( '.each-post-content-single-meta-cats-expanded' ).length ) {
				var $singleContentEachMetaCats = jQuery( "#each-post-content-single-meta-cats" );
				$singleContentEachMetaCats.removeClass( "each-post-content-single-meta-cats-expanded" );
				$singleContentEachMetaCats.children( "ul" ).find( "a" ).attr( "tabindex", "-1" );
			}
		}

		/* ----- 05. For 'Each Single Post Complete List of Tags' ------------------------- */

		// If "Auto-close" setting for "Each Single Post Complete List of Tags" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_single_tags_on" ) ) {
			if ( ! jQuery( e.target ).closest( '.each-post-content-single-meta-tags-expanded' ).length ) {
				var $singleContentEachMetaTags = jQuery( "#each-post-content-single-meta-tags" );
				$singleContentEachMetaTags.removeClass( "each-post-content-single-meta-tags-expanded" );
				$singleContentEachMetaTags.children( "ul" ).find( "a" ).attr( "tabindex", "-1" );
			}
		}

		/* ----- 06. For 'Each Post Related Posts' ---------------------------------------- */

		// If "Auto-close" setting for "Each Post Related Posts" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_single_related_on" ) ) {
			if ( ! jQuery( e.target ).closest( ".each-post-related-posts-expanded" ).length ) {
				jQuery( "#each-post-related-posts" ).removeClass( "each-post-related-posts-expanded" );
			}
		}

		/* ----- 07. For 'Comments List' -------------------------------------------------- */

		// If "Auto-close" setting for "Comments List" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_single_comments_on" ) ) {
			if ( ! jQuery( e.target ).closest( ".comments-list-expanded" ).length ) {
				jQuery( "#comments" ).removeClass( "comments-list-expanded" );
			}
		}

		/* ----- 08. For 'Trackbacks & Pingbacks List' ------------------------------------ */

		// If "Auto-close" setting for "Trackbacks & Pingbacks List" is set to "On" in the theme customizer...
		if ( jQuery( "body" ).hasClass( "ac_expdd_single_pings_on" ) ) {
			if ( ! jQuery( e.target ).closest( ".pings-list-expanded" ).length ) {
					jQuery( "#pings" ).removeClass( "pings-list-expanded" );
				}
		}

	}); // End of "jQuery( document ).on( "click touchend focusin", function(e){}".



	$widgetsSidebarRightsideBtnWrap.on( "click", function () {

		if ( BREAKPOINT_PC_TABLET < window.innerWidth ) {

			/* ----- 01. Toggle class 'sidebar-widgets-rightside-expanded' -------------------- */
			/* ----- 02. Toggle class '***-width-100' depending on whether -------------------- */
			/* --------- $widgetsSidebar has class 'sidebar-widgets-rightside-expanded'-------- */
			/* ----- 03. Activate/Disable keyboard accessible elements ------------------------ */
			if ( $widgetsSidebar.hasClass( "sidebar-widgets-rightside-expanded" ) ) {

				$widgetsSidebar.removeClass( "sidebar-widgets-rightside-expanded" );

				$contents.addClass( "contents-width-100" );
				$copyright.addClass( "copyright-width-100" );

				// When widgets sidebar on the right is collapsed, disable all keyboard accessible elements except for the toggle button.
				$widgetsSidebarRightsideKyBdAcssElems.not( "#sidebar-widgets-rightside-toggle-btn" ).attr( "tabindex", "-1" );

			} else {

				$widgetsSidebar.addClass( "sidebar-widgets-rightside-expanded" );

				// If the current page is not "Site Main", shrink the width, but if "Site Main", then the page keeps full width ( 100% ).
				if ( ! jQuery( "body" ).hasClass( "page-template-site-main-page" ) ) {
					$contents.removeClass( "contents-width-100" );
					$copyright.removeClass( "copyright-width-100" );
				}

				// When widgets sidebar on the right is expanded, activate all keyboard accessible elements.
				$widgetsSidebarRightsideKyBdAcssElems.attr( "tabindex", "0" );

			}

		} else {

			/* ----- 01. Toggle class 'sidebar-widgets-rightside-expanded' -------------------- */
			/* ----- 02. Toggle class '***-width-100' must not be removed --------------------- */
			/* ----- 03. Activate/Disable keyboard accessible elements ------------------------ */
			if ( $widgetsSidebar.hasClass( "sidebar-widgets-rightside-expanded" ) ) {

				$widgetsSidebar.removeClass( "sidebar-widgets-rightside-expanded" );

				// When widgets sidebar on the right is collapsed, disable all keyboard accessible elements except for the toggle button.
				$widgetsSidebarRightsideKyBdAcssElems.not( "#sidebar-widgets-rightside-toggle-btn" ).attr( "tabindex", "-1" );

			} else {

				$widgetsSidebar.addClass( "sidebar-widgets-rightside-expanded" );

				// When widgets sidebar on the right is expanded, activate all keyboard accessible elements.
				$widgetsSidebarRightsideKyBdAcssElems.attr( "tabindex", "0" );
			}
		}
	});



	/* ===== In order to toggle attribute 'disabled' depending on whether keywords are added ==== */
	var $searchBtn   = jQuery( ".tantyyellow-search-btn" );
	var $searchForm  = jQuery( ".tantyyellow-search-form" );
	var $searchBtn_i = jQuery( ".tantyyellow-search-btn i" );

	jQuery( ".tantyyellow-input-search" ).on( "input keyup blur click keydown keypress change touchstart focus", function(){
		var $inputText = jQuery( this ).val();
		if( ! $inputText ){
			$searchBtn.prop( "disabled", true );
			$searchForm.addClass    ( "searchword-not-added"  );
			$searchForm.removeClass ( "searchword-added"      );
			$searchBtn_i.addClass   ( "fa-search"             );
			$searchBtn_i.removeClass( "fa-angle-double-right" );
		}else{
			$searchBtn.prop( "disabled", false );
			$searchForm.removeClass ( "searchword-not-added"  );
			$searchForm.addClass    ( "searchword-added"      );
			if ( jQuery( this ).is( ":focus" ) ) {
				$searchBtn_i.removeClass( "fa-search"             );
				$searchBtn_i.addClass   ( "fa-angle-double-right" );
			} else {
				$searchBtn_i.addClass   ( "fa-search"             );
				$searchBtn_i.removeClass( "fa-angle-double-right" );
			}
		}
	});



	/* ===== Anonymous function defining "load", "resize", & "scroll" events ---================= */
	( function () {

		jQuery( window ).on({

			"load": function(e){
				func_for_events_load_resize(e);
				func_for_events_load_scroll();
				func_for_events_load_resize_scroll();
			},

			"resize": function(e) {
				func_timer_for_event_resize(e);
			},

			"scroll": function(e) {
				func_timer_for_event_scroll();
			}
		});

		var $timerId_for_event_resize = null;

		function func_timer_for_event_resize(e){
			// var $eventType = e.type;
			clearTimeout( $timerId_for_event_resize );
			$timerId_for_event_resize = setTimeout( function(){
				func_for_events_load_resize(e);
				func_for_events_load_resize_scroll();
			}, 300 );
		}

		function func_for_events_load_resize(e) {

			var $eventType = e.type;

			var $windowWidth = window.innerWidth;

			/* ----- 01. When the 'window width' is PC size..... ------------------------------ */
			if ( BREAKPOINT_PC_TABLET < $windowWidth ) {

				$headerNavList.addClass( "header-nav-is-top" );
				$headerNavList.removeClass( "header-nav-is-left" );

				$widgetsSidebar.addClass   ( "width-pc"     );
				$widgetsSidebar.removeClass( "width-tablet" );

				/* ..... 01. When the "load" event is listened..... ..................... */
				if ( "load" === $eventType ) {

					$contents.addClass( "contents-width-100" );
					$copyright.addClass( "copyright-width-100" );

					// When widgets sidebar on the right is collapsed, disable all keyboard accessible elements except for the toggle button.
					$widgetsSidebarRightsideKyBdAcssElems.not( "#sidebar-widgets-rightside-toggle-btn" ).attr( "tabindex", "-1" );

					// Expand the right side widgets sidebar.
					$widgetsSidebar.removeClass( "sidebar-widgets-rightside-expanded" );

				/* ..... 02. When the "resize" event is listened..... ................... */
				} else if ( "resize" === $eventType ) {

					// If the right side widgets sidebar is expanded when resized,.....
					if ( $widgetsSidebar.hasClass(  "sidebar-widgets-rightside-expanded"  ) ) {
						// If the current page is not "Site Main", shrink the width, but if "Site Main", then the page keeps full width ( 100% ).
						if ( ! jQuery( "body" ).hasClass( "page-template-site-main-page" ) ) {
							$contents.removeClass( "contents-width-100" );
							$copyright.removeClass( "copyright-width-100" );
						}
					}

				}

			/* ----- 02. When the 'window width' is Tablet size..... -------------------------- */
			} else {

				$headerNavList.removeClass( "header-nav-is-top" );
				$headerNavList.addClass( "header-nav-is-left" );

				$widgetsSidebar.removeClass( "width-pc" );
				$widgetsSidebar.addClass( "width-tablet" );

				$contents.addClass( "contents-width-100" );
				$copyright.addClass( "copyright-width-100" );

				// When widgets sidebar on the right is collapsed, disable all keyboard accessible elements except for the toggle button.
				$widgetsSidebarRightsideKyBdAcssElems.not( "#sidebar-widgets-rightside-toggle-btn" ).attr( "tabindex", "-1" );
			}
		}

		var $timerId_for_event_scroll = null;

		function func_timer_for_event_scroll(e){
			clearTimeout( $timerId_for_event_scroll );
			$timerId_for_event_scroll = setTimeout( function() {
				func_for_events_load_scroll();
				func_for_events_load_resize_scroll();
			} , 300 );
		}

		function func_for_events_load_scroll() {

			// Variables.
			var $scrollSize = window.pageYOffset;

			var $headerNav        = jQuery( "#header-nav" );
			var $breadCrumb       = jQuery( "#breadcrumb" );
			var $footerPageTopBtn = jQuery( "#footer-page-top-btn" );



			/* ----- In order to check whether a user scrolls down or not --------------------- */
			// When scrolled more than 100px, add a class "scrolled" and show the breadcrumb bar beneath the header nav menu.
			if( 100 < $scrollSize ){
				$headerNav.addClass( "scrolled" );
				$breadCrumb.addClass( "scrolled" );
			}else{
				$headerNav.removeClass( "scrolled" );
				$breadCrumb.removeClass( "scrolled" );
			}

			/* ----- In order to change "PAGE TOP" button opacity depending on scroll size ---- */
			if( 600 < $scrollSize ){
				$footerPageTopBtn.addClass   ( "scrolled-600" );
			}else{
				$footerPageTopBtn.removeClass( "scrolled-600" );
			}
			if( 700 < $scrollSize ){
				$footerPageTopBtn.addClass   ( "scrolled-700" );
			}else{
				$footerPageTopBtn.removeClass( "scrolled-700" );
			}
			if( 800 < $scrollSize ){
				$footerPageTopBtn.addClass   ( "scrolled-800" );
			}else{
				$footerPageTopBtn.removeClass( "scrolled-800" );
			}
			if( 900 < $scrollSize ){
				$footerPageTopBtn.addClass   ( "scrolled-900" );
			}else{
				$footerPageTopBtn.removeClass( "scrolled-900" );
			}
		}

		function func_for_events_load_resize_scroll() {

			/**
			 * In order that "Header nav" doesn't cover the page content,
			 * hide it partially when it has more than 2 rows.
			 *
			 * @link https://developer.mozilla.org/en-US/docs/Web/API/Element/getBoundingClientRect Element.getBoundingClientRect() method
			 */

			var $windowWidth = window.innerWidth;
			var $scrollSize  = window.pageYOffset;

			var $siteHeader                 = jQuery( "#site-header" );
			var $headerNavSidebarWrapHeight = $headerNavSidebarWrap.height();


			// Value of the CSS "top" attribute for <header id="site-header">.
			var $headerCssTopValue;

			// If "Window width" is PC size ( in short, if "Header nav menu" is not at the left with burger menu but at the top ).....
			if ( BREAKPOINT_PC_TABLET < $windowWidth ) {

				// If "Site header height" is over 100px ( in short, if "Header nav menu" has more than 2 rows ).....
				if ( 60 < $headerNavSidebarWrapHeight ) {
					if ( 100 < $scrollSize ) {
						$headerCssTopValue = 0 - ( $headerNavSidebarWrapHeight - 42 );
					} else {
						$headerCssTopValue = 0 - ( $headerNavSidebarWrapHeight - 75 );
					}
				}

			} else {

				$headerCssTopValue = 0;
			}

			// Update the CSS "top" attribute for <header id="site-header"> as well as "transition" attribute.
			$siteHeader.css( "top", $headerCssTopValue );
			$siteHeader.css( "transition", "all 0.5s ease-in" );
		}



	/* ######################################################################################################################## */
	} () ); /* ##### End of jQuery ############################################################################################ */
	/* ######################################################################################################################## */

} // End of "function tantyyellow_main_js() {".
