<?php
/**
 * ./template-parts/loops/loop-attachment.php
 * This template is used to display an attachment file
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Main Loop' for 'Attachment File' ################################################################################
// ########################################################################################################################

/* ===== If there are post(s)... ============================================================ */
if ( have_posts() ) :
	?>

	<section id="posts-loop-single-is-single-page" class="posts-loop loop-single container">

		<main class="row">

			<?php
			while ( have_posts() ) :

				the_post();
				?>

				<div class="posts-loop-wrapper container">

					<article id="post-<?php the_ID(); ?>" <?php post_class( 'post-loop excerpted-post' ); ?>>

						<!-- Each post header -->
						<header class="each-post-header clearfix">

							<div class="each-post-header-inner">

								<!-- Each post information -->
								<?php tantyyellow_output_template_parts_loop_each_post_infos( 'without-post-title', 'without-post-dates' ); ?>

								<!-- Each post background image. -->
								<div class="attachment-page-img  single-page-img">

									<img src="<?php echo esc_url( wp_get_attachment_url() ); ?>">

								</div><!-- /.attachment-page-img -->

							</div><!-- /.each-post-header-inner -->

						</header><!-- /.each-post-header -->

					</article><!-- /.post-loop -->

				</div><!-- /.posts-loop-wrapper -->

				<?php
			endwhile;
			?>

		</main><!-- /row -->

	</section><!-- /container -->



	<?php
	/* ===== If there is no post... ============================================================= */
else :
	tantyyellow_output_template_parts_nothing_exists_message();


	/* ===== End of "have_posts()" ============================================================== */
endif;
