<?php
/**
 * ./template-parts/loops/loop-main.php
 * This template is used to display all posts under 'Main Loop', such as "home.php", "archive.php", and so on.
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Main Loop' ######################################################################################################
// ########################################################################################################################

/* ===== If there are post(s)... ============================================================ */
if ( have_posts() ) :
	?>

	<?php
	if ( is_home() ) :
		?>
	<section id="posts-loop-main-is-posts-home-page" class="posts-loop loop-main container">
		<?php
	else :
		?>
	<section class="posts-loop loop-main container">
		<?php
	endif;
	?>

		<main class="row">
		<?php
		while ( have_posts() ) :
			the_post(); /* Push to next class until loop reaches the end */

			if ( is_home() ) :
				?>
			<div class="<?php echo ( is_sticky() ) ? 'sticky-post-wrapper' : ''; ?> posts-loop-wrapper col-xs-12 col-md-6 col-lg-6 col-ml-4 col-xl-6 col-xxl-4">
				<?php
			elseif ( is_archive() || is_search() ) :
				?>
			<div class="<?php echo ( is_sticky() ) ? 'sticky-post-wrapper' : ''; ?> posts-loop-wrapper container">
				<?php
			else :
				?>
			<div class="<?php echo ( is_sticky() ) ? 'sticky-post-wrapper' : ''; ?> posts-loop-wrapper">
				<?php
			endif;

			if ( is_sticky() ) :
				?>
				<span class="sticky-post">
					<?php
					if ( tantyyellow_get_site_basics_posts_subsection_all_posts_sticky_posts_badge_name_text() ) :
						echo esc_html( tantyyellow_get_site_basics_posts_subsection_all_posts_sticky_posts_badge_name_text() );
					endif;
					?>
				</span>
				<?php
			endif;
			?>

				<article id="post-<?php the_ID(); ?>"

				<?php
				echo ' ';

				if ( is_home() ) :
					post_class( 'post-loop excerpted-post' );
				elseif ( is_archive() || is_search() ) :
					post_class( 'post-loop excerpted-post row' );
				else :
					post_class( 'post-loop' );
				endif;
				?>
				><!-- /article -->

					<!-- Each post header -->
					<?php
					if ( is_home() ) :
						?>
					<header class="each-post-header">

						<?php
					elseif ( is_archive() || is_search() ) :
						?>
					<header class="each-post-header col-md-5 col-lg-4 col-xl-3">

						<?php
					else :
						?>
					<header class="each-post-header">

						<?php
					endif;
					?>

						<div class="each-post-header-inner">

							<!-- Each post background image. -->
							<?php tantyyellow_output_template_parts_loop_each_post_thumbnail_image( '' ); ?>

							<!-- Each post information -->
							<?php tantyyellow_output_template_parts_loop_each_post_infos( 'with-post-title', 'with-post-dates' ); ?>

						</div><!-- /.each-post-header-inner -->

					</header><!-- /.each-post-header -->



					<!-- Each Post Main -->
					<?php
					if ( is_home() ) :
						?>
					<div class="each-post-main-is-posts-home-page each-post-main">

						<?php
					elseif ( is_archive() || is_search() ) :
						?>
					<div class="each-post-main-is_archive each-post-main col-md-7 col-lg-8 col-xl-9">

						<?php
					else :
						?>
					<div class="each-post-main">

						<?php
					endif;
					?>

						<!-- Each post meta information -->
						<?php tantyyellow_output_template_parts_loop_each_post_meta_infos(); ?>

						<!-- Each post content -->
						<?php tantyyellow_output_template_parts_loop_each_post_content( $post->post_content, 'with-details-link', 'main_loop' ); ?>

					</div><!-- /.each-post-main -->

				</article><!-- /.posts-loop -->

			</div><!-- /.posts-loop-wrapper -->

			<?php
		endwhile;
		?>

		</main><!-- /row -->

	</section><!-- /.posts-loop .container -->

	<?php
	/**
	 * In order to output pagination if there are 2 or more pages.
	 *
	 * - $GLOBALS['wp_query'] is equal to $wp_query.
	 *
	 * @link https://www.php.net/manual/en/reserved.variables.globals.php "$GLOBALS"
	 */
	if ( $GLOBALS['wp_query']->max_num_pages > 1 ) :
		get_template_part( './template-parts/contents/paginations/pagination', 'posts' );
	endif;

	/* ===== If there is no post... ============================================================= */
else :
	tantyyellow_output_template_parts_nothing_exists_message();



	/* ===== End of "have_posts()" ============================================================== */
endif;
