<?php
/**
 * ./template-parts/loops/loop-page.php
 * This template is used to display "page.php"
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Main Loop' for 'page.php' #######################################################################################
// ########################################################################################################################

/* ===== If there are post(s)... ============================================================ */
if ( have_posts() ) :
	?>

	<section id="posts-loop-main-is-page" class="posts-loop loop-main container">

		<main class="row">
		<?php
		while ( have_posts() ) :
			the_post();
			?>

			<div class="<?php echo ( is_sticky() ) ? 'sticky-post-wrapper' : ''; ?> posts-loop-wrapper">

				<article id="post-<?php the_ID(); ?>" <?php post_class( 'post-loop' ); ?>>

					<!-- Each post header -->
					<header class="each-post-header">

						<div class="each-post-header-inner">

							<!-- Each post background image. -->
							<?php tantyyellow_output_template_parts_loop_each_post_thumbnail_image( '' ); ?>

							<!-- Each post information -->
							<?php tantyyellow_output_template_parts_loop_each_post_infos( 'without-post-title', 'without-post-dates' ); ?>

						</div><!-- /.each-post-header-inner -->

					</header><!-- /.each-post-header -->



					<!-- Each Post Main -->
					<div class="each-post-main">

						<!-- Each post content -->
						<?php
						tantyyellow_output_template_parts_loop_each_post_content( $post->post_content, 'without-details-link', 'main_loop' );
						?>

					</div><!-- /.each-post-main -->

				</article><!-- /.posts-loop -->



				<!-- Each post Comment -->
				<?php comments_template(); /* Load 'comments.php' */ ?>

			</div><!-- /.posts-loop-wrapper -->

			<?php
		endwhile;
		?>

		</main><!-- /row -->

	</section><!-- /.posts-loop .container -->



	<?php
	/* ===== If there is no post... ============================================================= */
else :
	tantyyellow_output_template_parts_nothing_exists_message();


	/* ===== End of "have_posts()" ============================================================== */
endif;
