<?php
/**
 * ./template-parts/loops/loop-single.php
 * This template is used to display a single post for "single.php"
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Main Loop' for 'Single Post Page'(single.php) ###################################################################
// ########################################################################################################################

/* ===== If there are post(s)... ============================================================ */
if ( have_posts() ) :
	?>

	<section id="posts-loop-single-is-single-page" class="posts-loop loop-single container">

		<main class="row">

		<?php
		while ( have_posts() ) :
			the_post();
			?>

			<div class="<?php echo is_sticky() ? 'sticky-post-wrapper' : ''; ?> posts-loop-wrapper container">

				<?php
				if ( is_sticky() ) :
					?>
				<span class="sticky-post">
					<?php
					if ( tantyyellow_get_site_basics_posts_subsection_all_posts_sticky_posts_badge_name_text() ) :
						echo esc_html( tantyyellow_get_site_basics_posts_subsection_all_posts_sticky_posts_badge_name_text() );
					endif;
					?>
				</span>
					<?php
				endif;
				?>

				<article id="post-<?php the_ID(); ?>" <?php post_class( 'post-loop excerpted-post' ); ?>>

					<!-- Each post header -->
					<header class="each-post-header clearfix">

						<div class="each-post-header-inner">

							<!-- Each post information -->
							<?php tantyyellow_output_template_parts_loop_each_post_infos( 'without-post-title', 'with-post-dates' ); ?>

							<!-- Each post background image. -->
							<?php tantyyellow_output_template_parts_loop_each_post_thumbnail_image( '' ); ?>

						</div><!-- /.each-post-header-inner -->

						<?php get_template_part( './template-parts/contents/paginations/pagination', 'singlepostsides' ); ?>

					</header><!-- /.each-post-header -->



					<?php
					if ( ! is_attachment() ) :
						?>

					<!-- Each post Main -->
					<div class="each-post-main">

						<!-- Each post meta information -->
						<?php tantyyellow_output_template_parts_loop_each_post_meta_infos(); ?>

						<!-- Each post content -->
						<?php tantyyellow_output_template_parts_loop_each_post_content( $post->post_content, 'without-details-link', 'main_loop' ); ?>

					</div><!-- /.each-post-main -->

						<?php
					endif;
					?>

				</article><!-- /.post-loop -->



				<?php get_template_part( './template-parts/contents/paginations/pagination', 'singlepostbottom' ); ?>



				<!-- Related Posts -->
				<div id="each-post-related-posts">

					<button id="each-post-related-posts-header" class="font-family_subheading_level<?php echo ( 'ja' === get_locale() ) ? ' font_weight_bold' : ''; ?>" aria-label="<?php echo esc_attr__( 'Click this title to open or close the list of this post\'s all related posts', 'tantyyellow' ); ?>" tabindex="0">
						<?php esc_html_e( 'Related Posts', 'tantyyellow' ); ?>
					</button>

					<div id="each-post-related-posts-content">
						<?php get_template_part( './template-parts/contents/loops/loop', 'sub' ); ?>
					</div>

				</div><!-- /#each-post-related-posts -->



				<!-- Each post Comment -->
				<?php comments_template(); /* Load 'comments.php' */ ?>

			</div><!-- /.posts-loop-wrapper -->

			<?php
		endwhile;

		if ( pings_open() ) :
			?>
			<div class="current-post-trackback-url">
				<h2 class="font-family_subheading_level"><?php esc_html_e( 'This Post\'s Trackback URL', 'tantyyellow' ); ?></h2>
				<p class="trackback_url allow_copy_to_clipboard" data-balloon="<?php esc_attr_e( 'Click to Copy URL', 'tantyyellow' ); ?>" data-balloon-pos="up" aria-label="<?php echo esc_attr__( 'Click and copy the Trackback URL of this post', 'tantyyellow' ); ?>" tabindex="0"><?php trackback_url(); ?></p>
			</div>
			<?php
		endif;
		?>

		</main><!-- /row -->

	</section><!-- /container -->



	<?php
	/* ===== If there is no post... ============================================================= */
else :
	tantyyellow_output_template_parts_nothing_exists_message();


	/* ===== End of "have_posts()" ============================================================== */
endif;
