<?php
/**
 * ./template-parts/contents/paginations/pagination-posts.php
 * This template is used to display pagination for 'Posts'
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Pagination' for 'Posts' #########################################################################################
// ########################################################################################################################

/* Start of anonymous function */
( function () {

	// In order to receive the values from "loop-sort-posts.php".
	$selected_orderby     = get_query_var( 'selected_orderby_type_to_pass_other_php_files' );
	$selected_asc_desc    = get_query_var( 'selected_order_asc_desc_to_pass_other_php_files' );
	$args_paged_param     = get_query_var( 'sorted_args_paged_to_pass_other_php_files' );
	$sorted_max_num_pages = get_query_var( 'sorted_posts_max_num_pages_to_pass_other_php_files' );

	$screen_reader_text = esc_html__( 'This is the paginated navigation for posts in this page', 'tantyyellow' );

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// +++++ Set previous & next posts page's text for pagination +++++++++++++++++++++++++++++++++++++++++

	if ( is_home() || is_date() ) {
		$prev_text = esc_html__( 'Newer', 'tantyyellow' );
		$next_text = esc_html__( 'Older', 'tantyyellow' );

	} else {
		$prev_text = esc_html__( 'Previous', 'tantyyellow' );
		$next_text = esc_html__( 'Next', 'tantyyellow' );
	}

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// +++++ Set the arguments & the max pages' number for pagination +++++++++++++++++++++++++++++++++++++

	$pagination_args = array(
		'prev_text'          => $prev_text,
		'next_text'          => $next_text,
		'show_all'           => false, /* Display all pages */
		'mid_size'           => 3,
		'screen_reader_text' => $screen_reader_text,
	);

	$pagination_max_num_pages = $GLOBALS['wp_query']->max_num_pages;

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// +++++ Output pagination if there are more 2 or more pages ++++++++++++++++++++++++++++++++++++++++++

	/**
	 * In order to output pagination if there are more 2 or more pages.
	 * - $GLOBALS['wp_query'] is equal to $wp_query.
	 *
	 * @link https://qiita.com/yakiniku48/items/0726d0c07b76cb74fa8c
	 * @link https://developer.wordpress.org/reference/classes/wp_query/#standard-loop-alternate "Standard Loop (Alternate)"
	 */
	echo wp_kses_post( tantyyellow_get_the_posts_pagination( $pagination_args, $pagination_max_num_pages ) );

} )();  /* End of anonymous function */
