<?php
/**
 * ./template-parts/contents/paginations/pagination-singlepostbottom.php
 * This template is used to display pagination for 'Single Post Page'(single.php) located underneath of it
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Pagination' for 'Single Post Page'(single.php) located underneath of it #########################################
// ########################################################################################################################
( function() {

	$next_post_url   = '';
	$next_post_title = '';

	if ( get_next_post() ) {
		$next_post_url   = get_permalink( get_next_post()->ID );
		$next_post_title = get_the_title( get_next_post() );
	}

	$prev_post_url   = '';
	$prev_post_title = '';

	if ( get_previous_post() ) {
		$prev_post_url   = get_permalink( get_previous_post()->ID );
		$prev_post_title = get_the_title( get_previous_post() );
	}

	?>

	<div class="pagination-single single-post-bottom-nav width-pc">
		<p class="pagination-single-inner font-family_subheading_level">

			<!-- Next/Previous post link -->
			<?php
			if ( get_next_post() ) :
				?>
			<span class="pagination-single-next">
				<a href="<?php echo esc_url( $next_post_url ); ?>" rel="next" aria-label="
					<?php
					if ( $next_post_title ) {
						printf(
							/* translators: %s: The title of the next post. */
							esc_attr__( 'Link to the next new post titled: %s', 'tantyyellow' ),
							esc_attr( wp_strip_all_tags( $next_post_title ) )
						);
					} else {
						echo esc_attr__( 'Link to the next new post', 'tantyyellow' );
					}
					?>
				">
					<?php echo wp_kses_post( $next_post_title ? $next_post_title : esc_html__( 'No Title', 'tantyyellow' ) ); ?>
				</a>
			</span>

				<?php
			else :
				?>
			<span class="pagination-single-next no-more">
				<a tabindex="0" aria-label="<?php echo esc_attr__( 'There is no more next new post', 'tantyyellow' ); ?>">
					<?php esc_html_e( 'no more post', 'tantyyellow' ); ?>
				</a>
			</span>

				<?php
			endif;

			if ( get_previous_post() ) :
				?>
			<span class="pagination-single-previous">
				<a href="<?php echo esc_url( $prev_post_url ); ?>" rel="next" aria-label="
					<?php
					if ( $prev_post_title ) {
						printf(
							/* translators: %s: The title of the previous post. */
							esc_attr__( 'Link to the previous old post titled: %s', 'tantyyellow' ),
							esc_attr( wp_strip_all_tags( $prev_post_title ) )
						);
					} else {
						echo esc_attr__( 'Link to the previous old post', 'tantyyellow' );
					}
					?>
				">
					<?php echo wp_kses_post( $prev_post_title ? $prev_post_title : esc_html__( 'No Title', 'tantyyellow' ) ); ?>
				</a>
			</span>

				<?php
			else :
				?>
			<span class="pagination-single-previous no-more">
				<a tabindex="0" aria-label="<?php echo esc_attr__( 'There is no more previous old post', 'tantyyellow' ); ?>">
					<?php esc_html_e( 'no more post', 'tantyyellow' ); ?>
				</a>
			</span>

				<?php
			endif;
			?>

		</p><!-- /.pagination-single-inner -->

	</div><!-- /.pagination-single -->



	<div class="pagination-single single-post-bottom-nav width-mobile-l">
		<p class="pagination-single-inner">

			<!-- Next/Previous post link -->
			<?php
			if ( get_next_post() ) :
				?>
			<span class="pagination-single-next">
				<a href="<?php echo esc_url( $next_post_url ); ?>" rel="next" aria-label="
					<?php
					printf(
						/* translators: %s: The title of the next post. */
						esc_attr__( 'Link to the next new post titled: %s', 'tantyyellow' ),
						esc_attr( wp_strip_all_tags( $next_post_title ) )
					);
					?>
				">
					<?php echo esc_html__( 'Newer', 'tantyyellow' ); ?>
				</a>
			</span>

				<?php
			else :
				?>
			<span class="pagination-single-next no-more">
				<a tabindex="0" aria-label="<?php echo esc_attr__( 'There is no more next new post', 'tantyyellow' ); ?>">
				<?php esc_html_e( 'no more post', 'tantyyellow' ); ?>
			</a>
			</span>

				<?php
			endif;

			if ( get_previous_post() ) :
				?>
			<span class="pagination-single-previous">
				<a href="<?php echo esc_url( $prev_post_url ); ?>" rel="next" aria-label="
					<?php
					printf(
						/* translators: %s: The title of the previous post. */
						esc_attr__( 'Link to the previous old post titled: %s', 'tantyyellow' ),
						esc_attr( wp_strip_all_tags( $prev_post_title ) )
					);
					?>
				">
					<?php echo esc_html__( 'Older', 'tantyyellow' ); ?>
				</a>
			</span>

				<?php
			else :
				?>
			<span class="pagination-single-previous no-more">
				<a tabindex="0" aria-label="<?php echo esc_attr__( 'There is no more previous old post', 'tantyyellow' ); ?>">
					<?php esc_html_e( 'no more post', 'tantyyellow' ); ?>
				</a>
			</span>

				<?php
			endif;
			?>

		</p><!-- /.pagination-single-inner -->

	</div><!-- /.pagination-single -->

	<?php
} )();
