<?php
/**
 * ./template-parts/contents/paginations/pagination-singlepostsides.php
 * This template is used to display pagination for 'Single Post Page'(single.php) located to left & right side of it
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### 'Pagination' for 'Single Post Page'(single.php) located to left & right side of it ###############################
// ########################################################################################################################
( function() {

	$next_post_url   = '';
	$next_post_title = '';

	if ( get_next_post() ) {
		$next_post_url   = get_permalink( get_next_post()->ID );
		$next_post_title = get_the_title( get_next_post() );
	}

	$prev_post_url   = '';
	$prev_post_title = '';

	if ( get_previous_post() ) {
		$prev_post_url   = get_permalink( get_previous_post()->ID );
		$prev_post_title = get_the_title( get_previous_post() );
	}

	?>

	<div class="pagination-single single-post-sides-arrow-nav">
		<p class="pagination-single-inner">

			<!-- Next/Previous post link -->
			<?php
			if ( get_next_post() ) :
				?>
			<span class="pagination-single-next">
				<a href="<?php echo esc_url( $next_post_url ); ?>" rel="next" aria-label="
					<?php
					printf(
						/* translators: %s: The title of the next post. */
						esc_attr__( 'Link to the next new post titled: %s', 'tantyyellow' ),
						esc_attr( wp_strip_all_tags( $next_post_title ) )
					);
					?>
				">
					<i class="fa fa-chevron-circle-left"></i>
				</a>
			</span>

				<?php
			endif;
			?>



			<?php
			if ( get_previous_post() ) :
				?>
			<span class="pagination-single-previous">
				<a href="<?php echo esc_url( $prev_post_url ); ?>" rel="next" aria-label="
					<?php
					printf(
						/* translators: %s: The title of the previous post. */
						esc_attr__( 'Link to the previous old post titled: %s', 'tantyyellow' ),
						esc_attr( wp_strip_all_tags( $prev_post_title ) )
					);
					?>
				">
					<i class="fa fa-chevron-circle-right"></i>
				</a>
			</span>

				<?php
			endif;
			?>

		</p><!-- /.pagination-single-inner -->

	</div><!-- /.pagination-single -->

	<?php
} )();
