<?php
/**
 * ./template-parts/headers/header-head.php
 * This template is used to display <head> for "header.php"
 *
 * @package tantyyellow
 */

// ########################################################################################################################
// ##### For <head> for 'Header Template'(header.php) #####################################################################
// ########################################################################################################################

// ***** In order to output tags to load 'metadata' for document ************************************************
?>

<head>

	<?php
	/** ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
	/** +++++  Tags for document title, character set, styles, links, and so on except for scripts +++++++++ */
	?>

	<!-- ===== Character Set ====================================================================== -->
	<meta charset="<?php bloginfo( 'charset' ); /* In order to internationalize. */ ?>">

	<!-- ===== Description which is displayed under the title resulted by 'Search Engine' ========= -->
	<meta name="description" content="<?php bloginfo( 'description' ); ?>">

	<!-- ===== Compatibility mode to display content in the highest mode in old IE, 8, 9 or 10 ==== -->
	<meta http-equiv="X-UA-Compatible" content="IE=edge">

	<!-- ===== Viewport for responsive website ==================================================== -->
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

	<!-- Title is defined at 'functions/setup.php' by 'add_theme_support. -->

	<!-- All other style tags are defined at 'functions/scripts.php' by 'wp_enqueue_style'. -->



	<?php wp_head(); /* Always have this just before the closing </head> tag of your theme, or you will break many plugins, which generally use this hook to add elements to <head> such as styles, scripts, and meta tags */ ?>

</head>
